CREATE OR REPLACE VIEW "public"."vEntidadeOvo" (
  codent,
  nomeent,
  descent,
  codstatusgeral,
  nomestatusgeral,
  codtipoent,
  nometipoent,
  tipoentmin,
  codbarras,
  coddesovo,
  nomedesovo,
  codstatusovo,
  nomestatusovo,
  codforovo,
  nomeforovo,
  codcorovo,
  nomecorovo,
  codcel,
  aquisovo,
  datacolovo,
  aspovo,
  pesoovo,
  porovo,
  incubavel)
AS
SELECT 
  entidade.codent,
  entidade.nomeent,
  entidade.descent,
  statusgeral.codstatusgeral,
  statusgeral.nomestatusgeral,
  tipoentidade.codtipoent,
  tipoentidade.nometipoent,
  tipoentidade.tipoentmin,
  ovo.codbarras,
  desovo.coddesovo,
  desovo.nomedesovo,
  statusovo.codstatusovo,
  statusovo.nomestatusovo,
  forovo.codforovo,
  forovo.nomeforovo,
  corovo.codcorovo,
  corovo.nomecorovo,
  ovo.codcel,
  ovo.aquisovo,
  ovo.datacolovo,
  ovo.aspovo,
  ovo.pesoovo,
  ovo.porovo,
  ovo.incubavel
FROM
 public.entidade
 INNER JOIN public.statusgeral ON (public.entidade.codstatusgeral=public.statusgeral.codstatusgeral)
 INNER JOIN public.tipoentidade ON (public.entidade.codtipoent=public.tipoentidade.codtipoent)
 INNER JOIN public.ovo ON (public.entidade.codent=public.ovo.codovo)
 INNER JOIN public.statusovo ON (public.ovo.codstatusovo=public.statusovo.codstatusovo)
 INNER JOIN public.forovo ON (public.ovo.codforovo=public.forovo.codforovo)
 INNER JOIN public.desovo ON (public.ovo.coddesovo=public.desovo.coddesovo)
 INNER JOIN public.corovo ON (public.ovo.codcorovo=public.corovo.codcorovo)
WHERE
  (public.entidade.codent = public.ovo.codovo) AND 
  (public.entidade.codstatusgeral = public.statusgeral.codstatusgeral) AND 
  (public.entidade.codtipoent = public.tipoentidade.codtipoent) AND 
  (public.ovo.coddesovo = public.desovo.coddesovo) AND 
  (public.ovo.codstatusovo = public.statusovo.codstatusovo) AND 
  (public.ovo.codforovo = public.forovo.codforovo) AND 
  (public.ovo.codcorovo = public.corovo.codcorovo) AND 
  (public.entidade.codtipoent = 1)
-- 
-- 
-- ***
-- 
-- Consulta que relaciona a view EntidadeOvo  tabela Clula (permitindo associao de ovos s respectivas clulas)
-- 
-- SELECT 
--   public."vEntidadeOvo".codent as codentovo,
--   public."vEntidadeOvo".nomeent as nomeentovo,
--   public."vEntidadeOvo".descent as descentovo,
--   public.entidade.nomeent as nomeentcel,
--  public.entidade.descent as descentcel
-- FROM
--  public."vEntidadeOvo"
--  INNER JOIN public.entidade ON (public."vEntidadeOvo".codcel=public.entidade.codent)