CREATE OR REPLACE VIEW "public"."vOvoProjetoIncubacaoNascimentoBandeja" (
  codovo,
  codbarras,
  aquisovo,
  datacolovo,
  aspovo,
  pesoovo,
  porovo,
  incubavel,
  coddesovo,
  nomedesovo,
  codstatusovo,
  nomestatusovo,
  codforovo,
  nomeforovo,
  codcorovo,
  nomecorovo,
  codcel,
  nomeent,
  codproj,
  codesp,
  nomeesp,
  codtipoent,
  nometipoent,
  codstatusproj,
  nomestatusproj,
  siglaproj,
  nomeproj,
  datainiproj,
  dataprevproj,
  datafimproj,
  descproj,
  numinc,
  codinc,
  codstatusin,
  nomestatusin,
  datainiinc,
  dataprevinc,
  datafiminc,
  numovoinii,
  numovodesi,
  numovotransf,
  obsstatusinc,
  nlinbanenc,
  ncolbanenc,
  codposbanenc,
  codmotdesenc,
  motdes,
  ovotransf,
  codenc,
  nomeenc,
  nposenc,
  dataaloenc,
  dataretenc,
  tposenc,
  codnas,
  datainiinas,
  dataprevnas,
  datafimnas,
  numovoinin,
  numovodesn,
  numovorec,
  obsstatusnas,
  nlinban,
  ncolban,
  codstatusgeral,
  codmotdes,
  ovonasceu,
  codposbannes,
  codnes,
  nomenes,
  tcolnes,
  codban,
  tlinban,
  tcolban,
  nomeban,
  nposnes,
  dataalones,
  dataretnes)
AS
SELECT 
  ovo.codovo,
  ovo.codbarras,
  ovo.aquisovo,
  ovo.datacolovo,
  ovo.aspovo,
  ovo.pesoovo,
  ovo.porovo,
  ovo.incubavel,
  desovo.coddesovo,
  desovo.nomedesovo,
  statusovo.codstatusovo,
  statusovo.nomestatusovo,
  forovo.codforovo,
  forovo.nomeforovo,
  corovo.codcorovo,
  corovo.nomecorovo,
  ovo.codcel,
  entidade.nomeent,
  projeto.codproj,
  especieave.codesp,
  especieave.nomeesp,
  tipoentidade.codtipoent,
  tipoentidade.nometipoent,
  statusprojeto.codstatusproj,
  statusprojeto.nomestatusproj,
  projeto.siglaproj,
  projeto.nomeproj,
  projeto.datainiproj,
  projeto.dataprevproj,
  projeto.datafimproj,
  projeto.descproj,
  projeto.numinc,
  incubacao.codinc,
  statusincnas.codstatusin,
  statusincnas.nomestatusin,
  incubacao.datainiinc,
  incubacao.dataprevinc,
  incubacao.datafiminc,
  incubacao.numovoinii,
  incubacao.numovodesi,
  incubacao.numovotransf,
  incubacao.obsstatusinc,
  inctement.nlinban,
  inctement.ncolban,
  posbanenc.codposbanenc,
  motivodescarte.codmotdes,
  motivodescarte.motdes,
  inctement.ovotransf,
  incubadora.codenc,
  incubadora.nomeenc,
  posbanenc.nposenc,
  posbanenc.dataaloenc,
  posbanenc.dataretenc,
  incubadora.tposenc,
  nascimento.codnas,
  nascimento.datainiinas,
  nascimento.dataprevnas,
  nascimento.datafimnas,
  nascimento.numovoinin,
  nascimento.numovodesn,
  nascimento.numovorec,
  nascimento.obsstatusnas,
  nastement.nlinban,
  nastement.ncolban,
  nastement.codstatusgeral,
  nastement.codmotdes,
  nastement.ovonasceu,
  posbannes.codposbannes,
  nascedouro.codnes,
  nascedouro.nomenes,
  nascedouro.tcolnes,
  bandeja.codban,
  bandeja.tlinban,
  bandeja.tcolban,
  bandeja.nomeban,
  posbannes.nposnes,
  posbannes.dataalones,
  posbannes.dataretnes
FROM
 public.ovo
 INNER JOIN public.desovo ON (public.ovo.coddesovo=public.desovo.coddesovo)
 INNER JOIN public.statusovo ON (public.ovo.codstatusovo=public.statusovo.codstatusovo)
 INNER JOIN public.forovo ON (public.ovo.codforovo=public.forovo.codforovo)
 INNER JOIN public.corovo ON (public.ovo.codcorovo=public.corovo.codcorovo)
 INNER JOIN public.inctement ON (public.ovo.codovo=public.inctement.codent)
 INNER JOIN public.nastement ON (public.ovo.codovo=public.nastement.codent)
 INNER JOIN public.entidade ON (public.ovo.codcel=public.entidade.codent)
 INNER JOIN public.posbannes ON (public.posbannes.codposbannes=public.nastement.codposbannes)
 INNER JOIN public.bandeja ON (public.bandeja.codban=public.posbannes.codban)
 INNER JOIN public.nascedouro ON (public.posbannes.codnes=public.nascedouro.codnes)
 INNER JOIN public.posbanenc ON (public.posbanenc.codposbanenc=public.inctement.codposbanenc)
 INNER JOIN public.incubadora ON (public.posbanenc.codenc=public.incubadora.codenc)
 INNER JOIN public.incubacao ON (public.incubacao.codinc=public.inctement.codinc)
 INNER JOIN public.projeto ON (public.projeto.codproj=public.incubacao.codproj)
 INNER JOIN public.statusincnas ON (public.incubacao.codstatusin=public.statusincnas.codstatusin)
 INNER JOIN public.especieave ON (public.projeto.codesp=public.especieave.codesp)
 INNER JOIN public.tipoentidade ON (public.projeto.codtipoent=public.tipoentidade.codtipoent)
 INNER JOIN public.motivodescarte ON (public.inctement.codmotdes=public.motivodescarte.codmotdes)
 INNER JOIN public.nascimento ON (public.incubacao.codinc=public.nascimento.codinc)
  AND (public.nascimento.codnas=public.nastement.codnas)
 INNER JOIN public.statusprojeto ON (public.projeto.codstatusproj=public.statusprojeto.codstatusproj)
WHERE
  (public.ovo.coddesovo = public.desovo.coddesovo) AND 
  (public.ovo.codstatusovo = public.statusovo.codstatusovo) AND 
  (public.ovo.codforovo = public.forovo.codforovo) AND 
  (public.ovo.codcorovo = public.corovo.codcorovo) AND 
  (public.ovo.codcel = public.entidade.codent) AND 
  (public.projeto.codesp = public.especieave.codesp) AND 
  (public.projeto.codtipoent = public.tipoentidade.codtipoent) AND 
  (public.projeto.codstatusproj = public.statusprojeto.codstatusproj) AND 
  (public.projeto.codproj = public.incubacao.codproj) AND 
  (public.incubacao.codinc = public.inctement.codinc) AND 
  (public.ovo.codovo = public.inctement.codinc) AND 
  (public.inctement.codmotdes = public.motivodescarte.codmotdes) AND 
  (public.inctement.codposbanenc = public.posbanenc.codposbanenc) AND 
  (public.posbanenc.codenc = public.incubadora.codenc) AND 
  (public.incubacao.codstatusin = public.statusincnas.codstatusin) AND 
  (public.ovo.codovo = public.nastement.codent) AND 
  (public.nastement.codnas = public.nascimento.codnas) AND 
  (public.nascimento.codinc = public.incubacao.codinc) AND 
  (public.nastement.codposbannes = public.posbannes.codposbannes) AND 
  (public.posbannes.codnes = public.nascedouro.codnes) AND 
  (public.posbannes.codban = public.bandeja.codban)