CREATE VIEW "public"."vOvoIncubacaoNascimento" (
  codovo,
  codbarras,
  coddesovo,
  nomestatusovo,
  nomeforovo,
  nomecorovo,
  nomeent_cel,
  aquisovo,
  datacolovo,
  aspovo,
  pesoovo,
  porovo,
  incubavel,
  nlinban_inc,
  ncolban_inc,
  codmotdes_inc,
  ovotransf,
  codproj,
  siglaproj,
  nomeproj,
  nomeenc,
  datainiinc,
  nomeesp,
  datainiinas,
  datafimnas,
  obsstatusnas,
  nlinban_nas,
  ncolban_nas,
  nomenes,
  codmotdes_nas)
AS
SELECT 
  ovo.codovo,
  ovo.codbarras,
  ovo.coddesovo,
  statusovo.nomestatusovo,
  forovo.nomeforovo,
  corovo.nomecorovo,
  "vEntidadeCelula".nomeent AS nomeent_cel,
  ovo.aquisovo,
  ovo.datacolovo,
  ovo.aspovo,
  ovo.pesoovo,
  ovo.porovo,
  ovo.incubavel,
  inctement.nlinban AS nlinban_inc,
  inctement.ncolban AS ncolban_inc,
  inctement.codmotdes AS codmotdes_inc,
  inctement.ovotransf,
  projeto.codproj,
  projeto.siglaproj,
  projeto.nomeproj,
  incubadora.nomeenc,
  incubacao.datainiinc,
  especieave.nomeesp,
  nascimento.datainiinas,
  nascimento.datafimnas,
  nascimento.obsstatusnas,
  nastement.nlinban AS nlinban_nas,
  nastement.ncolban AS ncolban_nas,
  nascedouro.nomenes,
  nastement.codmotdes AS codmotdes_nas
FROM
 public.ovo
 INNER JOIN public.entidade ON (public.ovo.codovo=public.entidade.codent)
 INNER JOIN public.inctement ON (public.ovo.codovo=public.inctement.codent)
 INNER JOIN public.nastement ON (public.ovo.codovo=public.nastement.codent)
 INNER JOIN public.statusovo ON (public.ovo.codstatusovo=public.statusovo.codstatusovo)
 INNER JOIN public.forovo ON (public.ovo.codforovo=public.forovo.codforovo)
 INNER JOIN public.corovo ON (public.ovo.codcorovo=public.corovo.codcorovo)
 INNER JOIN public."vEntidadeCelula" ON (public.ovo.codcel=public."vEntidadeCelula".codent)
 INNER JOIN public.posbanenc ON (public.inctement.codposbanenc=public.posbanenc.codposbanenc)
 INNER JOIN public.posbannes ON (public.nastement.codposbannes=public.posbannes.codposbannes)
 INNER JOIN public.nascedouro ON (public.posbannes.codnes=public.nascedouro.codnes)
 INNER JOIN public.incubadora ON (public.posbanenc.codenc=public.incubadora.codenc)
 INNER JOIN public.nascimento ON (public.nastement.codnas=public.nascimento.codnas)
 INNER JOIN public.incubacao ON (public.incubacao.codinc=public.inctement.codinc)
  AND (public.nascimento.codinc=public.incubacao.codinc)
 INNER JOIN public.projeto ON (public.incubacao.codproj=public.projeto.codproj)
 INNER JOIN public.especieave ON (public.projeto.codesp=public.especieave.codesp)
WHERE
  (public.ovo.codovo = public.entidade.codent) AND 
  (public.ovo.codovo = public.inctement.codent) AND 
  (public.ovo.codovo = public.nastement.codent) AND 
  (public.inctement.codinc = public.incubacao.codinc) AND 
  (public.incubacao.codproj = public.projeto.codproj) AND 
  (public.projeto.codesp = public.especieave.codesp) AND 
  (public.incubacao.codinc = public.nascimento.codinc) AND 
  (public.nastement.codnas = public.nascimento.codnas) AND 
  (public.ovo.codstatusovo = public.statusovo.codstatusovo) AND 
  (public.ovo.codforovo = public.forovo.codforovo) AND 
  (public.ovo.codcorovo = public.corovo.codcorovo) AND 
  (public.ovo.codcel = public."vEntidadeCelula".codent) AND 
  (public.inctement.codposbanenc = public.posbanenc.codposbanenc) AND 
  (public.posbanenc.codenc = public.incubadora.codenc) AND 
  (public.posbannes.codposbannes = public.nastement.codposbannes) AND 
  (public.posbannes.codnes = public.nascedouro.codnes)