package broker;

import java.sql.*;

/**
 * Cria e fecha conexes com o banco de dados. 
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 * @see         Connection
 */
public class BrokerConexao 
{
	// declarao de variveis para Connection
	private  String hostName = "localhost";
	private  String userName = "postgres";
	private  String password = "incubus";   
	private  String jdbcDriver = "org.postgresql.Driver";
	private  String dataBaseName = "sisinc";
	private  String dataBasePrefix = "jdbc:postgresql://";
	private  String dabaBasePort = "5432";
	private  String url = dataBasePrefix + hostName + ":"+dabaBasePort+"/" + dataBaseName + "/";
	public Connection con = null;
 
	/**
	 * Cria a conexo com o banco de dados.
	 * @return url, userName, password
	 */
	public  Connection criaConexao()
	{
	    try 
	    {
	    	if (con == null)
	    	{
	    		Class.forName(jdbcDriver);
	    		con = DriverManager.getConnection(url, userName, password);
	    		System.out.println("Conectou: "+url);
	        }
	        else if (con.isClosed())
	        {
	        	con = null;
	        	return DriverManager.getConnection(url, userName, password);
	        }
	    }
	    catch (ClassNotFoundException e)
	    {   
	    	e.printStackTrace();
	    }
	    catch (SQLException e)
	    {
	    	e.printStackTrace();
	    }
	    return con;
	}

	/**
	 * Fecha a conexo com o banco de dados.
	 */
	public  void fechaConexao()
	{
		try
	    {
			con.close();
			System.out.println("Desconectou");
	    }
	    catch(SQLException ex)
	    {
	    	ex.printStackTrace();
	    }
	}
}