package broker;

import java.sql.*;
import java.util.Vector;
import javaUtil.TransferData;

/**
 * 
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class BrokerConsulta extends BrokerConexao{
	private Connection con;
	private Statement stmt;
	private Vector vetor,vetor2;
	private ResultSet rs;
	private String aux,retorna,entMin,nomeEsp;
	private int retornaData,ret;

	/**
	 * RETORNA BANDEJA
	 * @return vetor com as bandejas
	 */
	public Vector retornaBandeja()
	{
		try
		{
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+='"'+"vBandejaIncubadoraPosicao"+'"'+" ";
			aux+="ORDER BY CodBan;";
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodBan");
	        	x+=" - ";
	        	x+=rs.getString("NomeBan");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaBandeja -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaBandeja.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA BANDEJA ALOCADA EM INCUBADORA
	 * @return vetor com  bandejas no retiradas de incubadora
	 */
	public Vector retornaBandejaAlocadaI()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con =criaConexao();
			stmt=con.createStatement();
			aux="SELECT Bandeja.CodBan,Bandeja.NomeBan FROM ";
			aux+="Bandeja INNER JOIN PosBanEnc ON ";
			aux+="Bandeja.CodBan=PosBanEnc.CodBan ";
			aux+="WHERE PosBanEnc.DataRetEnc IS NULL;";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodBan");
				x+=" - ";
				x+=rs.getString("NomeBan");
				vetor.addElement(x);
			}
			rs.close();    
			stmt.close();
			con.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaBandejaAlocadaI -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaBandejaAlocadaI.");
		}
		return vetor;
	}

	/**
	 * RETORNA BANDEJA ALOCADA EM NASCEDOURO
	 * @return vetor com  bandejas no retiradas de nascedouro
	 */
	public Vector retornaBandejaAlocadaN()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT Bandeja.CodBan,Bandeja.NomeBan FROM ";
			aux+="Bandeja INNER JOIN PosBanNes ON ";
			aux+="Bandeja.CodBan=PosBanNes.CodBan ";
			aux+="WHERE PosBanNes.DataRetNes IS NULL;";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodBan");
				x+=" - ";
				x+=rs.getString("NomeBan");
				vetor.addElement(x);
			}
			rs.close();    
			stmt.close();
			con.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaBandejaAlocadaN -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaBandejaAlocadaN.");
		}	
		return vetor;
	}
	
	/**
	 * RETORNA BANDEJA DESALOCADA
	 * @return vetor com as bandejas desalocadas
	 */
	public Vector retornaBandejaDesalocada()
	{
		try
		{
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			// pesquisa bandeja retirada de incubadora
			aux="SELECT Bandeja.CodBan,Bandeja.NomeBan FROM ";
			aux+="Bandeja INNER JOIN PosBanEnc ON ";
			aux+="Bandeja.CodBan=PosBanEnc.CodBan WHERE ";
			aux+="DataRetEnc>DataAloEnc;";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodBan");
        		x+=" - ";
        		x+=rs.getString("NomeBan");
        		vetor.addElement(x);
			}
			rs.close();
			// pesquisa bandeja retirada de nascedouro
			aux="SELECT bandeja.CodBan,bandeja.NomeBan FROM ";
			aux+="Bandeja INNER JOIN PosBanNes ON ";
			aux+="Bandeja.CodBan=PosBanNes.CodBan WHERE ";
			aux+="DataRetNes>DataAloNes;";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodBan");
				x+=" - ";
				x+=rs.getString("NomeBan");
				vetor.addElement(x);
			}
			rs.close();
			// pesquisa bandeja no alocada em incubadora e nascedouro
			aux="SELECT DISTINCT bandeja.CodBan,bandeja.NomeBan FROM ";
			aux+="Bandeja WHERE ";
			aux+="CodBan NOT IN(";
			aux+="SELECT CodBan FROM PosBanEnc) AND ";
			aux+="CodBan NOT IN(";
			aux+="SELECT CodBan FROM PosBanNes) ";
			aux+="ORDER BY CodBan;";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodBan");
				x+=" - ";
				x+=rs.getString("NomeBan");
				vetor.addElement(x);
			}
			rs.close();
			stmt.close();
			con.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaBandejaDesalocada -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaBandejaDesalocada.");
		}			
		return vetor;
	}
	
	/**
	 * RETORNA BANDEJA EM POSIO DE NASCEDOURO
	 * @return vetor com as bandejas em nascedouro
	 */
	public Vector retornaBandejaNas()
	{
		try
		{
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+='"'+"vBandejaNascedouroPosicao"+'"'+" ";
			aux+="ORDER BY CodBan;";
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodBan");
	        	x+=" - ";
	        	x+=rs.getString("NomeBan");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaBandejaNas -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaBandejaNas.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA CLULA
	 * @return vetor com as clulas ativas
	 */
	public Vector retornaCelula()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Celula INNER JOIN Entidade ";
			aux+="ON Entidade.CodEnt=Celula.CodCel ";
			aux+="WHERE CodStatusGeral=1 ";
			aux+="ORDER BY NomeEnt;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodCel");
				x+=" - ";
        		x+=rs.getString("NomeEnt");
        		vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaCelula -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaCelula.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA DADOS DO NASCIMENTO COM BANDEJA
	 * @param  nascimento cdigo do nascimento
	 * @return vetor com bandeja, nascedouro e entidade
	 */
	public Vector retornaDadosNas2(String nascimento)
	{	
		String x="";
		int i=0;
		try
		{
			vetor = new Vector();
			vetor2 = new Vector();
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT DISTINCT ";
			aux+="PosBanNes.CodBan,";
			aux+="PosBanNes.CodNes,";
			aux+="NasTemEnt.CodEnt FROM ";
			aux+="PosBanNes JOIN NasTemEnt ON ";
			aux+="PosBanNes.CodPosBanNes=NasTemEnt.CodPosBanNes ";
			aux+="WHERE NasTemEnt.CodNas="+nascimento+";";  
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodBan");
				x+="-";
				x+=rs.getString("CodNes");
				x+=":";
				x+=rs.getString("CodEnt");
				vetor.add(x);
			}
			rs.close();
			stmt.close();
       	
			for(i = 0; i < vetor.size(); i++)
			{
				stmt=con.createStatement();
				String aux1=(String)vetor.elementAt(i);
				String novo=aux1.substring(aux1.indexOf(":")+1);
				aux="SELECT NomeEnt FROM ";
				aux+="Entidade WHERE CodEnt="+novo+";";
				rs=stmt.executeQuery(aux);
				rs.next();
				vetor2.addElement(aux1+"-"+rs.getString("NomeEnt"));
				rs.close();
				stmt.close();
			}
        con.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDadosNas2 -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDadosNas2.");
		}		
		return vetor2;
	}

	/**
	 * RETORNA DADOS DO NASCIMENTO COM INCUBAO
	 * @param  nascimento cdigo do nascimento
	 * @return incubao e data de trmino do nascimento
	 */
	public String retornaDadosNas(String nascimento)
	{	
		TransferData dt = new TransferData();
		String x="";
		try
		{
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Nascimento WHERE ";
			aux+="CodStatusIN=1 AND ";
			aux+="CodNas="+nascimento+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodInc");
				x+="-";
				x+=dt.DataPApresentar(rs.getString("DataPrevNas"));
			}
			rs.close();
			con.close();
			stmt.close();
			int index=x.indexOf("-");
			String aux1=x.substring(0,index-1);
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Incubacao WHERE ";
			aux+="CodStatusIN=1 AND ";
			aux+="CodInc="+aux1+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x+="|";
				x+=rs.getString("DataIniInc");
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDadosNas -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDadosNas.");
		}	
		return x;
	}
	
	/**
	 * RETORNA DADOS PARA PGINA DE ENTRADA
	 * @return retorna com projetos, incubaes e nascimentos ativos
	 */
	public String retornaDadosGerais()
	{
		try
		{	
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			// pesquisa todos os projetos
			aux="SELECT COUNT(*) AS ";
			aux+="Projetos FROM Projeto;"; 
			rs=stmt.executeQuery(aux);
			rs.next();
			x=rs.getString("Projetos");
			x+="-";
			rs.close();
			// pesquisa todos os projetos ativos
			aux="SELECT COUNT(*) AS ";
			aux+="Projetos FROM Projeto ";
			aux+="WHERE CodStatusProj=1;";
			rs=stmt.executeQuery(aux);
			rs.next();
			x+=rs.getString("Projetos");
			x+=":";
			rs.close();
			// pesquisa todos as incubaes ativas
			aux="SELECT COUNT(*) AS ";
			aux+="Incubacoes FROM Incubacao ";
			aux+="WHERE CodStatusIN=1;";
			rs=stmt.executeQuery(aux);
			rs.next();
			x+=rs.getString("Incubacoes");
        	x+="-";
        	rs.close();
        	// pesquisa todos os nascimentos ativos
        	aux="SELECT COUNT(*) AS ";
        	aux+="Nascimentos FROM Nascimento ";
        	aux+="WHERE CodStatusIN=1;";
        	rs = stmt.executeQuery(aux);
        	rs.next();
        	x+=rs.getString("Nascimentos");
        	rs.close();
        	System.out.println(x);
        	retorna=x;
        	rs.close();
			con.close();
        	stmt.close();
		}
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDadosGerais -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDadosGerais.");
		}		
		return retorna;
	}
	
	/**
	 * RETORNA DATA DE INCIO DE INCUBAO
	 * @param  inc cdigo da incubao
	 * @return data de incio de uma incubao
	 */
	public String retornaDataIniInc(String inc)
	{	
		TransferData dt = new TransferData();
		String x="";
		try
		{
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT DataIniInc FROM ";
			aux+="Incubacao WHERE CodInc="+inc+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("DataIniInc");
			}
			rs.close();
			con.close();
			stmt.close();
			x=dt.DataPApresentar(x);
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDataIniInc -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDataIniInc.");
		}				
		return x;
	}
	
	/**
	 * RETORNA DATA PERINC DE AVE DE PROJETO
	 * @param  proj cdigo do projwto
	 * @return data que  o perodo de incubao da espcie
	 */
	public int retornaDataEspecie(String proj){
		try
		{	
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT PerInc FROM ";
			aux+="EspecieAve WHERE ";
			aux+="CodEsp=(";
			aux+="SELECT Projeto.CodEsp WHERE ";
			aux+="Projeto.CodProj="+proj+");"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	retornaData=rs.getInt("PerInc"); 
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDataEspecie -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDataEspecie.");
		}		
		return retornaData;
	}
	
	/**
	 * RETORNA DATA PERNAS DE AVE DE PROJETO
	 * @param  proj cdigo do projwto
	 * @return data que  o perodo de nascimento da espcie
	 */
	public int retornaDataEspecieNas(String proj){
		try
		{	
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT PerNas FROM ";
			aux+="EspecieAve WHERE ";
			aux+="CodEsp=(";
			aux+="SELECT Projeto.CodEsp WHERE ";
			aux+="Projeto.CodProj="+proj+");"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	retornaData=rs.getInt("PerNas"); 
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDataEspecieNas -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDataEspecieNas.");
		}	
		return retornaData;
	}
	
	/**
	 * RETORNA EM OVO SEU TIPO DE COR
	 * @return vetor com tipos de cor ativos de ovo
	 */
	public Vector retornaCorOvo()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="CorOvo WHERE ";
			aux+="CodStatusGeral=1 ";
			aux+="ORDER BY NomeCorOvo;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodCorOvo");
				x+=" - ";
				x+=rs.getString("NomeCorOvo");
				vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaCorOvo -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaCorOvo.");
		}		
		return vetor;
	}

	/**
	 * RETORNA EM OVO SEU TIPO DE DESINFECO
	 * @return vetor com tipos de desinfeco ativos de ovo
	 */
	public Vector retornaDesOvo()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="DesOvo WHERE ";
			aux+="CodStatusGeral=1 ";
			aux+="ORDER BY NomeDesOvo;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodDesOvo");
				x+=" - ";
				x+=rs.getString("NomeDesOvo");
				vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaDesOvo -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaDesOvo.");
		}		
		return vetor;
	}

	/**
	 * RETORNA EM OVO SEU TIPO DE FORMATO
	 * @return vetor com tipos de formato ativos de ovo
	 */
	public Vector retornaForOvo()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="ForOvo WHERE ";
			aux+="CodStatusGeral=1 ";
			aux+="ORDER BY NomeForOvo;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodForOvo");
				x+=" - ";
				x+=rs.getString("NomeForOvo");
				vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaForOvo -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaForOvo.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA ENTIDADE
	 * @return vetor com entidades
	 */
	public Vector retornaEntidade()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Entidade;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodEnt");
	        	x+=" - ";
	        	x+=rs.getString("NomeEnt");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEntidade -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEntidade.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA ENTIDADES DE TIPOS DE ENTIDADE EM INCUBAO
	 * @param  inc cdigo da incubao
	 * @return cdigo e nome das entidades dos tipos em incubao
	 */
	public Vector retornaEntidadeInc(String inc)
	{
		try
		{ 
			String auxCodTipo="";
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Entidade WHERE ";
			aux+="CodEnt=(";
			aux+="SELECT CodEnt FROM "+inc+");"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				auxCodTipo=rs.getString("CodTipoEnt");
			}
			rs.close();
			aux="SELECT * FROM ";
			aux+="Entidade WHERE ";
			aux+="CodTipoEnt="+auxCodTipo+";";
			rs=stmt.executeQuery(aux);
			while(rs.next())
	        {
	        	x=rs.getString("CodEnt");
	        	x+=" - ";
	        	x+=rs.getString("NomeEnt");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEntidadeInc -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEntidadeInc.");
		}				
		return vetor;
	}
	
	/**
	 * RETORNA ENTIDADES EM INCUBAO
	 * @param  inc cdigo da incubao
	 * @return cdigo e nome das entidades em incubao
	 */
	public Vector retornaEntInc(String inc)
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Entidade WHERE ";
			aux+="Entidade.CodEnt=(";
			aux+="SELECT CodEnt FROM ";
			aux+="Incubacao WHERE ";
			aux+="CodInc="+inc+");"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodEnt");
	        	x+=" - ";
	        	x+=rs.getString("NomeEnt");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaTipoEntidade -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaTipoEntidade.");
		}				
		return vetor;
	}
	
	/**
	 * RETORNA ENTIDADES POR ENTIDADE MNIMA DE PROJETO
	 * @param  projeto cdigo do projeto
	 * @return vetor com as entidades por tipo de entidade
	 */
	public Vector retornaEntidadeProj(String projeto)
	{
		try
		{   String auxCodTipo="";
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT CodTipoEnt FROM ";
			aux+="Projeto WHERE ";
			aux+="CodProj="+projeto+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				auxCodTipo=rs.getString("CodTipoEnt");
			}
			rs.close();
			aux="SELECT * FROM ";
			aux+="Entidade WHERE ";
			aux+="CodTipoEnt="+auxCodTipo+";";
			rs=stmt.executeQuery(aux);
			while(rs.next())
	        {
	        	x=rs.getString("CodEnt");
	        	x+=" - ";
	        	x+=rs.getString("NomeEnt");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
	        System.out.println(aux);
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEntidadeProj -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEntidadeProj.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA ENTIDADE POR TIPO
	 * @param  ent cdigo do tipo de entidade
	 * @return vetor com as entidades por tipo
	 */
	public Vector retornaEntidade(String ent)
	{
		try
		{
			String pai;
			int filho=Integer.parseInt(ent);
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			if((filho >= 1) && (filho <= 8))
			{
				pai=Integer.toString(filho+1);
			}
			else
			{
				pai="0";
			}																
			System.out.println("pai:"+pai+"ent:"+ent);
			aux="SELECT * FROM ";
			aux+="Entidade WHERE ";
			aux+="CodTipoEnt='"+pai+"';"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodEnt");
	        	x+=" - ";
	        	x+=rs.getString("NomeEnt");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
	    }	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEntidade -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEntidade.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA ESPCIE
	 * @return vetor com as espcies
	 */
	public Vector retornaEspecie()
	{
		try
		{	
			vetor = new Vector();
			int cont=0;
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="EspecieAve ORDER BY CodEsp;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodEsp");
	        	x+=" - ";
	        	x+=rs.getString("NomeEsp");
	        	vetor.addElement(x);
	         	cont++;
	        }
	        if(cont==0){
	        	x="0";
	        	x+=" - ";
	        	x+="nenhum";
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEspecie -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEspecie.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA ESPCIE DE PROJETO
	 * @return nome da espcie do projeto
	 */
	public String retornaEspProjeto(String projeto)
	{
		try
		{
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="EspecieAve JOIN Projeto ";
			aux+="ON EspecieAve.CodEsp=Projeto.CodEsp ";
			aux+="WHERE Projeto.CodProj="+projeto+";"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("NomeEsp");
	        }
	        nomeEsp=x;
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEspProjeto -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEspProjeto.");
		}	
		return nomeEsp;
	}
	
	/**
	 * RETORNA INCUBAO
	 * @param  proj cdigo do projeto
	 * @return vetor com as incubaes e datas de incio
	 */
	public Vector retornaIncubacao(String proj)
	{
		TransferData dt=new TransferData();
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Incubacao WHERE ";
			aux+="CodStatusIN=1 AND ";
			aux+="CodProj="+proj+" ";
			aux+="ORDER BY CodInc;"; 
			rs = stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodInc");
	        	x+=" de ";
	        	x+=dt.DataPApresentar(rs.getString("DataIniInc"));
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaIncubacao -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaIncubacao.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA INCUBADORA
	 * @return vetor com as incubadoras ativas
	 */
	public Vector retornaIncubadora()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Incubadora WHERE ";
			aux+="CodStatusGeral=1 ORDER BY NomeEnc;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodEnc");
	        	x+=" - ";
	        	x+=rs.getString("NomeEnc");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaIncubadora -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaIncubadora.");
		}	
		return vetor;
	}
	
	/**
	 * RETORNA GRUPO DE USURIO
	 * @return vetor com grupos de usurio
	 */
	public Vector retornaGrupo()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Grupo ORDER BY NomeGru;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodGru");
	        	x+=" - ";
	        	x+=rs.getString("NomeGru");
	        	vetor.addElement(x);
	       }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaGrupo -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaGrupo.");
		}	
		return vetor;
	}
	
	/**
	 * RETORNA NASCEDOURO
	 * @return vetor com os nascedouros ativos
	 */
	public Vector retornaNascedouro()
	{
		try
		{	
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Nascedouro ";
			aux+="WHERE CodStatusGeral=1 ";
			aux+="ORDER BY NomeNes;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodNes");
				x+=" - ";
				x+=rs.getString("NomeNes");
				vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaNascedouro -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaNascedouro.");
		}			
		return vetor;
	}
	
	/**
	 * RETORNA NASCIMENTO
	 * @param  proj cdigo do projeto
	 * @return vetor com os nascimentos e datas de incio
	 */
	public Vector retornaNascimento(String proj)
	{
		TransferData dt = new TransferData();
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Nascimento JOIN Incubacao ON ";
			aux+="Incubacao.CodInc=Nascimento.CodInc WHERE ";
			aux+="Incubacao.CodProj="+proj+" AND "; 
			aux+="Nascimento.CodStatusIN=1 ";
			aux+="ORDER BY Nascimento.CodInc;";
			rs = stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodNas");
        		x+=" de ";
        		x+=dt.DataPApresentar(rs.getString("DataIniINas"));
        		vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaIncubacao -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaIncubacao.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA POSIO DE BANDEJA EM INCUBADORA
	 * @param  cod cdigo da bandeja
	 * @return posies de bandeja e incubadora
	 */
	public String retornaPosBan(String cod){
		try
		{	
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+='"'+"vBandejaIncubadoraPosicao"+'"'+" ";
			aux+="WHERE CodBan="+cod+";"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("NomeEnc");
	        	x+=" - ";
	        	x+=rs.getString("CodPosBanEnc");
	        	x+=" : ";
	        	x+=rs.getString("NPosEnc");
	       }
	        retorna=x;
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaPosBan -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaPosBan.");
		}	
		return retorna;
	}
	
	/**
	 * RETORNA POSIO DE BANDEJA EM NASCEDOURO
	 * @param  cod cdigo da bandeja
	 * @return posies de bandeja e nascedouro
	 */
	public String retornaPosBanNas(String cod){
		try
		{	
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+='"'+"vBandejaNascedouroPosicao"+'"'+" ";
			aux+="WHERE CodBan="+cod+";"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("NomeNes");
	        	x+=" - ";
	        	x+=rs.getString("CodPosBanNes");
	        	x+=" : ";
	        	x+=rs.getString("NPosNes");
	       }
	        System.out.println("aux:"+aux);
	        retorna=x;
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaPosBanNas -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaPosBanNas.");
		}			
		return retorna;
	}

	/**
	 * RETORNA POSIO DE INCUBADORA
	 * @return vetor com posies e incubadora ativa
	 */
	public Vector retornaPosEnc()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			String n="";
			int i=0;
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Incubadora WHERE ";
			aux+="CodStatusGeral=1 ORDER BY NomeEnc;"; 
			rs=stmt.executeQuery(aux);
        	n=rs.getString("CodEnc");
        	n+=" - ";
        	n=rs.getString("TPosEnc");
	        while(i <= Integer.parseInt(n))
	        {
	        	x=rs.getString("CodEnc");
	        	x+=" - ";
	        	x+=rs.getString(i+"");
	        	i++;
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaPosEnc -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaPosEnc.");
		}			
		return vetor;
	}
	
	/**
	 * RETORNA PROJETO
	 * @return vetor com os projetos
	 */
	public Vector retornaProjeto()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Projeto ORDER BY SiglaProj;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodProj");
	        	x+=" - ";
	        	x+=rs.getString("SiglaProj");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaProjeto -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaProjeto.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA PROJETO DE INCUBAO
	 * @param  inc cdigo da incubao
	 * @return cdigo do projeto da incubao
	 */
	public String retornaProjInc(String inc)
	{
		try
		{
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Incubacao WHERE ";
			aux+="CodInc="+inc+";";
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodProj");
	        	retorna=x;
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaProjInc -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaProjInc.");
		}		
		return retorna;
	}
	
	/**
	 * RETORNA PROPRIEDADE
	 * @return vetor com as propriedades ativas
	 */
	public Vector retornaPropriedade()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Propriedade INNER JOIN Entidade ";
			aux+="ON Entidade.CodEnt=Propriedade.CodProp ";
			aux+="WHERE CodStatusGeral=1 ";
			aux+="ORDER BY NomeEnt;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodProp");
				x+=" - ";
				x+=rs.getString("NomeEnt");
				vetor.addElement(x);
			}
			rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaPropriedade -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaPropriedade.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA QUANTIDADE DE ENTIDADE EM INCUBAO
	 * @param  incubacao cdigo da incubao
	 * @param  entidade  cdigo da entidade
	 * @return vetor com status geral
	 */
	public String buscarQuantidade(String incubacao,String entidade)
	{
		try
		{	
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT COUNT(CodInc) FROM ";
			aux+="IncTemEnt WHERE ";
			aux+="CodInc="+incubacao+" AND ";
			aux+="OvoTransf<>'S';"; 
			rs = stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	retorna=rs.getString(1);
	        	retorna+="-";
	        }
	        rs.close();
	        aux="SELECT COUNT(CodInc) FROM ";
	        aux+="IncTemEnt WHERE ";
	        aux+="CodInc="+incubacao+" AND ";
	        aux+="CodEnt="+entidade+" AND ";
	        aux+="OvoTransf<>'S';"; 
	        rs = stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	retorna+=rs.getString(1);
	        }
	        rs.close();
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no buscarQuantidade -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo buscarQuantidade.");
		}			
		return retorna;
	}
	
	/**
	 * RETORNA TAMANHO DA BANDEJA
	 * @param  cod cdigo da bandeja
	 * @return nmero de linhas e colunas
	 */	
	public String retornaTamBan(String cod)
	{
		String posicao="";
		try
		{   
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="Bandeja WHERE ";
			aux+="CodBan="+cod+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
	        {
	        	x=rs.getString("tLinBan");
	        	x+="-";
	        	x+=rs.getString("tColBan");
	        	posicao=x;
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}		
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaTamBan -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaTamBan.");
		}					
		return posicao;
	}
	
	/**
	 * RETORNA TIPO DE ENTIDADE
	 * @return vetor com os tipos de entidade
	 */
	public Vector retornaTipoEntidade()
	{
		try
		{	
			vetor = new Vector();
			int cont=0;
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="TipoEntidade ORDER BY CodTipoEnt;"; 
			rs=stmt.executeQuery(aux);
			rs.next();
	        while(rs.next())
	        {
	        	  x=rs.getString("CodTipoEnt");
	        	  x+=" - ";
	        	  x+=rs.getString("NomeTipoEnt");
	        	  vetor.addElement(x);
	        	  cont++;
	        }
	        if(cont == 0)
	        {
	        	x="0";
	        	x+=" - ";
	        	x+="nenhum";
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaTipoEntidade -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaTipoEntidade.");
		}			
		return vetor;
	}
	
	/**
	 * RETORNA TIPO DE ENTIDADE MNIMA DO PROJETO
	 * @param  projeto cdigo do projeto
	 * @return cdigo e nome da entidade mnima
	 */
	public String retornaEntMin(String projeto)
	{
		try
		{
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="TipoEntidade JOIN Projeto ";
			aux+="ON TipoEntidade.CodTipoEnt=Projeto.CodTipoEnt ";
			aux+="WHERE Projeto.CodProj="+projeto+ ";"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodTipoEnt");
	        	x+=" - ";
	        	x+=rs.getString("NomeTipoEnt");
	        	entMin=x;
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaEntMin -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaEntMin.");
		}				
		return entMin;
	}
	
	/**
	 * RETORNA TIPO DE STATUS DE OVO
	 * @return vetor com status ativos de ovo
	 */
	public Vector retornaStatusOvo()
	{
		try
		{	
			vetor=new Vector();
			String x="";
			con=criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="StatusOvo WHERE ";
			aux+="CodStatusGeral=1 ";
			aux+="ORDER BY NomeStatusOvo;"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodStatusOvo");
				x+=" - ";
				x+=rs.getString("NomeStatusOvo");
				vetor.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaStatusOvo -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaStatusOvo.");
		}				
		return vetor;
	}
	
	/**
	 * RETORNA TIPO DE STATUS DE PROJETO
	 * @return vetor com status de projeto
	 */
	public Vector retornaStatusProj()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="StatusProjeto WHERE ";
			aux+="CodStatusProj!=3";
			aux+="ORDER BY CodStatusProj;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodStatusProj");
	        	x+=" - ";
	        	x+=rs.getString("NomeStatusProj");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaStatusProj -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaStatusProj.");
		}			
		return vetor;
	}
	
	/**
	 * RETORNA TIPO DE STATUS DE USURIO
	 * @return vetor com status de usurio
	 */
	public Vector retornaStatusUsu()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="StatusUsuario WHERE ";
			aux+="CodStatusUsu!=3";
			aux+="ORDER BY NomeStatusUsu;"; 
			rs=stmt.executeQuery(aux);
		    while(rs.next())
		    {
		        x=rs.getString("CodStatusUsu");
		        x+=" - ";
		        x+=rs.getString("NomeStatusUsu");
		        vetor.addElement(x);
		    }
		    rs.close();
		    con.close();
		    stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaStatusUsu -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaStatusUsu.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA TIPO DE STATUS GERAL
	 * @return vetor com status geral
	 */
	public Vector retornaStatus()
	{
		try
		{
			vetor = new Vector();
			String x="";
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM ";
			aux+="StatusGeral ";
			aux+="ORDER BY CodStatusGeral;"; 
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodStatusGeral");
	        	x+=" - ";
	        	x+=rs.getString("NomeStatusGeral");
	        	vetor.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaStatus -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaStatus.");
		}		
		return vetor;
	}
	
	/**
	 * RETORNA TOTAL DE POSIES DE INCUBADORA
	 * @param  inc cdigo da incubadora
	 * @return nmero total de posies de uma incubadora
	 */
	public int retornaPosinc(String inc){
		try
		{
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT TPosEnc FROM ";
			aux+="Incubadora WHERE CodEnc="+inc+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				ret=rs.getInt("TPosEnc"); 
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaPosinc -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaPosinc.");
		}			
		return ret;
	}

	/**
	 * RETORNA TOTAL DE POSIES DE NASCEDOURO
	 * @param  inc cdigo da incubadora
	 * @return nmero total de posies de um nascedouro
	 */
	public int retornaPosnas(String nas){
		try
		{	 
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT TColNes FROM ";
			aux+="Nascedouro WHERE CodNes="+nas+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				ret=rs.getInt("TColNes"); 
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("SQL Exception no retornaPosnas -> "+aux);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu do Mtodo retornaPosnas.");
		}		
		return ret;
	}
}