package broker;

import classepersistente.Entidade;
import java.sql.*;
import java.util.*;

/**
 * Materizaliza e desmaterializa a classe no banco de dados.
 * <p>
 * Efetua insero, atualizao e consulta.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class BrokerEntidade extends BrokerConexao
{
	// declarao de variveis
	private String nome;
	private String descEnt;
	private String entidade;
	private	String tipoEntidade;
	private String statusGeral;
	// variveis do broker
	private Vector consulta;
	private Statement stmt;
	private String aux,aux1,aux2;
	private ResultSet rs;

	/**
	 * Insere dados no banco de dados.
	 * @return sucesso ou falha SQL
	 */
	public String desmaterializar()throws SQLException
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux2="SELECT * FROM ";
			aux2+="TipoEntidade WHERE ";
			aux2+="CodTipoEnt="+tipoEntidade+";"; 
			rs=stmt.executeQuery(aux2);
	        while(rs.next())
	        {
	        	aux1=rs.getString("NomeTipoEnt");
	        }	
	        // insere na tabela entidade
			aux="INSERT INTO Entidade VALUES("; 
			aux+="DEFAULT";
			aux+=",1";
			aux+=","+tipoEntidade;
			aux+=",'"+nome+"'";
			aux+=",'"+descEnt+"');";
			// insere na tabela especfica
			aux+="INSERT INTO "+aux1+" VALUES(";
			aux+="DEFAULT";
			aux+=",'"+entidade+"');";
			stmt.execute(aux);
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerEntidade: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerEntidade.");
			return e.getMessage().toString();
		}		
		return "Entidade";
	}   
	
	/**
	 * Atualiza dados no banco de dados.
	 * @param  sigla 
	 * @return sucesso ou falha SQL
	 */
	public String desmaterializar(String sigla)throws SQLException
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="UPDATE Entidade SET  ";
			aux+="CodStatusGeral="+statusGeral;
			aux+=",CodTipoEnt="+tipoEntidade;
			aux+=",NomeEnt='"+nome+"'";
			aux+=",DescEnt='"+descEnt+"' ";
			aux+="WHERE NomeEnt='"+nome+"';"; 
			stmt.executeUpdate(aux);
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerEntidade: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerEntidade.");
			return e.getMessage().toString();
		}		
		return "EntidadeAltera";
	}   
	
	/**
	 * Atualiza para excludo no banco de dados.
	 * @param  siglaProj 
	 * @return sucesso ou falha SQL
	 */
	public String mudarEntidade(String siglaProj)
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="";
			aux="UPDATE entidade SET   codstatusgeral='"+2+"' where  codent='"+//codent+"';"; 
			stmt.executeQuery(aux);
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
			return e.getMessage().toString();
		}	
		return "UsuarioExclui";
	}
	

//	metodo retorna conslta de usuarios   
	



public Vector retornaConsulta(String t,String valor)					
{
	String x="",aux2,auxent="",auxtipo="";
	
	
	try
	{
		consulta = new Vector();
		con = criaConexao();
		stmt=con.createStatement();
		if(t=="d"){
			System.out.println("entrou em d");
			int index = valor.indexOf('-');
			String valor1=valor.substring(0,index-1);
			String valor2=valor.substring(index+1);
			aux="select * from entidade where nomeent like'%"+valor1+"%'and '%"+valor2+"')";
			
		}else{
			if(t=="n"){							//pega pelo nome dos entidades
				System.out.println("entrou em n");
				aux="select * from entidade where nomeent like '%"+valor+"%'";
			
			}else{
				if(t=="a"){						//pega tudo
					System.out.println("entrou em a");
					aux="select * from entidade";
				}else{							//pega pelo tipo
					if(t=="t"){
						aux="select * from entidade where codtipoent like '%"+valor+"%'";
						
					}
				}
			}
		}
		rs = stmt.executeQuery(aux);

        while(rs.next())
        {
        	auxent=rs.getString("codent");
        	auxtipo=rs.getString("codtipoent");
        }
		rs.close();
		
		aux2="";
		aux2 =  "SELECT "; 
		aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
		aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
		aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
		aux2 += "public.entidade.descent AS descentgai,";
		aux2 +=  "public.entidade.nomeent";
		aux2 +=" FROM ";
		aux2 += "public."+'"'+"vEntidadeCelula"+'"';
		aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
		aux2 +="where codentecel=";
		System.out.println("sql:"+aux2);
		aux2="";
		if(auxtipo.equals("2")){
				aux2 =  "SELECT "; 
				aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
				aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
				aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
				aux2 += "public.entidade.descent AS descentgai,";
				aux2 +=  "public.entidade.nomeent";
				aux2 +="FROM";
				aux2 += "public."+'"'+"vEntidadeCelula"+'"';
				aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
				aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("1")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("2")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("3")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("4")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("5")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("6")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("7")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
		}
		if(auxtipo.equals("8")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
			
	}
		if(auxtipo.equals("9")){
			aux2 =  "SELECT "; 
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".codent AS codentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".nomeent AS nomeentcel,";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"'+".descent AS descentcel,";
			aux2 += "public.entidade.descent AS descentgai,";
			aux2 +=  "public.entidade.nomeent";
			aux2 +="FROM";
			aux2 += "public."+'"'+"vEntidadeCelula"+'"';
			aux2 +=" INNER JOIN public.entidade ON (public."+'"'+"vEntidadeCelula"+'"'+".codgai=public.entidade.codent)";
			aux2 +="where codentecel="+auxent; 
			
	}
		rs = stmt.executeQuery(aux2);
        while(rs.next())
        {
        	x = rs.getString("codent");
        	x += " - ";
        	x += rs.getString("nomeent");
        	x += " : ";
        	x += rs.getString("tipoent");
        	x += " | ";
        	x += rs.getString(""); 
        	consulta.addElement(x);
        }
        rs.close();
		con.close();
        stmt.close();
	}	
	catch(SQLException e)
	{
		System.out.println (e.getMessage());
		e.printStackTrace();
		
	}
	catch(Exception e)
	{
		System.out.println (e.getMessage());
		e.printStackTrace();
		
	}		
	
	return consulta;
}
// mtodo que controi um objeto entidade

public Entidade materializar(String codigo)
{
	Entidade  auxEntidade= new Entidade();
	
	try
	{
		con = criaConexao();
		stmt=con.createStatement();
		aux="select * from entidade where codent='"+codigo+"'"; 
		rs = stmt.executeQuery(aux);
        while(rs.next())
        {
        	auxEntidade.setNome(rs.getString("nomeent"));
        	auxEntidade.setEntidade(rs.getString("codent"));
        	auxEntidade.setTipoEntidade(rs.getString("codtipoent"));
        	auxEntidade.setDescEnt(rs.getString("descent"));
        	
        	
        }
        rs.close();
		con.close();
        stmt.close();
	}	
	catch(SQLException e)
	{
		System.out.println (e.getMessage());
		e.printStackTrace();
		System.out.println("SQL Exception no metodo desmaterializar  BrokerUsuario Query->" + aux);
	}
	catch(Exception e)
	{
		System.out.println (e.getMessage());
		e.printStackTrace();
		System.out.println("saiu no");}		
	
	return auxEntidade;
}

	// beans - gets e sets
	public String getEntidade() {
		return entidade;
	}
	public void setEntidade(String entidade) {
		this.entidade = entidade;
	}
	public String getTipoEntidade() {
		return tipoEntidade;
	}
	public void setTipoEntidade(String tipoEntidade) {
		this.tipoEntidade = tipoEntidade;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getDescEnt() {
		return descEnt;
	}
	public void setDescEnt(String descEnt) {
		this.descEnt = descEnt;
	}
	public String getStatusGeral() {
		return statusGeral;
	}
	public void setStatusGeral(String statusGeral) {
		this.statusGeral = statusGeral;
	}
}