package broker;

import classepersistente.Projeto;
import javaUtil.TransferData;
import java.sql.*;
import java.util.*;

/**
 * Materizaliza e desmaterializa a classe no banco de dados.
 * <p>
 * Efetua insero, atualizao e consulta.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class BrokerProjeto extends BrokerConexao
{
	// declarao de variveis
	private	String siglaProj;
	private String nome;
	private String entidade;
	private	String especie;
	private String dataInicio;
	private String dataPrev;
	private String dataFim;
	private String descricao;
	private String status;
	// variveis do broker
	private Vector consulta;
	private Statement stmt;
	private String aux;
	private ResultSet rs;

	/**
	 * Insere dados no banco de dados.
	 * @return sucesso ou falha SQL
	 */
	public String desmaterializar()throws SQLException
	{
		TransferData data = new TransferData(); 
		try
		{	
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="INSERT INTO Projeto(";
			aux+="CodProj";
			aux+=",CodEsp";
			aux+=",CodTipoEnt";
			aux+=",CodStatusProj";
			aux+=",SiglaProj";
			aux+=",NomeProj";
			aux+=",DataIniProj";
			aux+=",DataPrevProj";
			aux+=",DataFimProj";
			aux+=",DescProj";
			aux+=",NumInc) ";
			aux+="VALUES("; 
			aux+="DEFAULT";
			aux+=","+especie;
			aux+=","+entidade;
			aux+=",1";
			aux+=",'"+siglaProj+"'";
			aux+=",'"+nome+"'";
			aux+=",'"+data.DataPGravar(dataInicio)+"'";
			aux+=",'"+data.DataPGravar(dataPrev)+"'";
			aux+=",'01-01-9999'";
			aux+=",'"+descricao+"'";
			aux+=",0);";
			stmt.execute(aux);
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerProjeto: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerProjeto.");
			return e.getMessage().toString();
		}	
		return "Projeto";
	}   
	
	/**
	 * Atualiza dados no banco de dados.
	 * @param  sigla sigla do projeto
	 * @return sucesso ou falha SQL
	 */
	public String desmaterializar(String sigla)throws SQLException
	{
		TransferData data = new TransferData(); 
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="UPDATE Projeto SET ";
			aux+="CodEsp='"+especie+"'";
			aux+=",CodTipoEnt='"+entidade+"'";
			aux+=",CodStatusProj='"+status+"'";
			aux+=",NomeProj='"+nome+"'";
			aux+=",DataIniProj='"+data.DataPGravar(dataInicio)+"'";
			aux+=",DataPrevProj='"+dataPrev+"'";
			aux+=",DescProj='"+descricao+"' ";
			aux+="WHERE SiglaProj='"+sigla+"';"; 
			stmt.executeUpdate(aux);
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerProjeto: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerProjeto.");
			return e.getMessage().toString();
		}
		return "ProjetoAltera";	    
	}   
	
	/**
	 * Atualiza para excludo no banco de dados.
	 * @param  siglaProj sigla do projeto
	 * @return sucesso ou falha SQL
	 */
	public String mudarProjeto(String siglaProj)
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="UPDATE projeto SET ";
			aux+="CodStatusProj=3 ";
			aux+="WHERE SiglaProj='"+siglaProj+"';"; 
			stmt.executeQuery(aux);
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerProjeto: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerProjeto.");
			return e.getMessage().toString();
		}	
		return "ProjetoExclui";
	}
	
	/**
	 * Consulta no banco de dados.
	 * @param  t      
	 * @param  valor  
	 * @param  status 
	 * @return consulta, vetor contendo o resultado
	 */  	
	public Vector retornaConsulta(String t, String valor, String status)					
	{
		TransferData data = new TransferData(); 
		String x="";
		try
		{
			consulta = new Vector();
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Projeto WHERE "; 
			aux+="CodStatusProj="+status+" AND ";
			// pesquisa por: SiglaProj
			if(t=="s"){
				aux+="UPPER(SiglaProj) LIKE ";
				aux+="UPPER('%"+valor+"%');";	
			}
			else
			{	
				// pesquisa por: NomeProj
				if(t=="n"){
					aux+="UPPER(NomeProj) LIKE ";
					aux+="UPPER('%"+valor+"%');";
				}
				else
				{
					// pesquesa por: DataIniProj
					if(t=="d")
					{
						aux+="DataIniProj<='"+data.DataPGravar(valor)+"'";
					}
					else
					{
						// pesquisa por sem: DataFimProj
						if(t=="a")
						{
							aux+="DataFimProj='9999-01-01';";
						}
						else
						{
							if(t=="x")
							{
								// pesquisa por: SiglaProj e DataIniProj
								int index = valor.indexOf('-');
								String valor1=valor.substring(0,index-1);
								String valor2=valor.substring(index+1);
								aux+="(DataIniProj<'"+valor2+"' AND ";
								aux+="DataFimProj>'"+valor2+"') AND ";
								aux+="(SiglaProj LIKE '%"+valor1+"%';)";
							}
							else
							{
								// pesquisa por: NomeProj e DataIniProj
								if(t=="y"){
									int index = valor.indexOf('-');
									String valor1=valor.substring(0,index-1);
									String valor2=valor.substring(index+1);
									aux+="(DataIniProj<'"+valor2+"' AND ";
									aux+="DataFimProj>'"+valor2+"') AND ";
									aux+="(NomeProj LIKE '%"+valor1+"%';)";
								}
							}
						}
					}
				}
			}
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("SiglaProj");
				x+=" * ";
				x+=rs.getString("NomeProj");
				x+=" : ";
				x+=rs.getString("DataIniProj");
        		x+=" | ";
        		x+=rs.getString("CodProj");
        		consulta.addElement(x);
			}
			rs.close();
			con.close();
        	stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerProjeto: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerProjeto.");
		}
		return consulta;
	}

	/**
	 * Constri objeto especificado.
	 * @param  codigo cdigo do projeto
	 * @return o objeto e seus atributos
	 */  
	public Projeto materializar(String codigo)
	{
		Projeto auxProjeto = new Projeto();
		try
		{
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Projeto ";
			aux+="WHERE CodProj="+codigo+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				auxProjeto.setSiglaProj(rs.getString("SiglaProj"));
				auxProjeto.setNome(rs.getString("NomeProj"));
				auxProjeto.setEntidade(rs.getString("CodTipoEnt"));
        		auxProjeto.setEspecie(rs.getString("CodEsp"));
				auxProjeto.setDataPrev(rs.getString("DataPrevProj"));
				auxProjeto.setDataInicio(rs.getString("DataIniProj"));
				auxProjeto.setDataFim(rs.getString("DataFimProj"));
				auxProjeto.setDescricao(rs.getString("DescProj"));
        		auxProjeto.setStatus(rs.getString("CodStatusProj"));
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerProjeto: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerProjeto.");
		}		
		return auxProjeto;
	}

	// beans - gets e sets
	public String getSiglaProj() {
		return siglaProj;
	}
	public void setSiglaProj(String siglaProj) {
		this.siglaProj = siglaProj;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getEntidade() {
		return entidade;
	}
	public void setEntidade(String entidade) {
		this.entidade = entidade;
	}
	public String getEspecie() {
		return especie;
	}
	public void setEspecie(String especie) {
		this.especie = especie;
	}
	public String getDataInicio() {
		return dataInicio;
	}
	public void setDataInicio(String dataInicio) {
		this.dataInicio = dataInicio;
	}
	public String getDataPrev() {
		return dataPrev;
	}
	public void setDataPrev(String dataPrev) {
		this.dataPrev = dataPrev;
	}
	public String getDataFim() {
		return dataFim;
	}
	public void setDataFim(String dataFim) {
		this.dataFim = dataFim;
	}
	public String getDescricao() {
		return descricao;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	//beans do broker
	public String getAux() {
		return aux;
	}
	public void setAux(String aux) {
		this.aux = aux;
	}
	public Vector getConsulta() {
		return consulta;
	}
	public void setConsulta(Vector consulta) {
		this.consulta = consulta;
	}
}