package broker;

import classepersistente.Usuario;
import java.sql.*;
import java.util.*;

/**
 * Materizaliza e desmaterializa a classe no banco de dados.
 * <p>
 * Efetua insero, atualizao e consulta.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class BrokerUsuario extends BrokerConexao
{
	// declarao de variveis
	private	String matricula;
	private String nome;
	private String grupo;
	private String senha;
	private String telres;
	private	String telcom;
	private String telcel;
	private String email;
	private String status;
	// variveis do broker
	private Vector consulta;
	private Statement stmt;
	private String aux;
	private ResultSet rs;

	/**
	 * Insere dados no banco de dados.
	 * @return sucesso ou falha SQL
	 */
	public String desmaterializar()throws SQLException
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="INSERT INTO Usuario(";
			aux+="CodUsu";
			aux+=",CodStatusUsu";
			aux+=",CodGru";
			aux+=",MatrUsu";
			aux+=",NomeUsu";
			aux+=",SenCrt";
			aux+=",DataInc";
			aux+=",TelRes";
			aux+=",TelCom";
			aux+=",TelCel";
			aux+=",Email";
			aux+=",UltAltSen";
			aux+=",UltLogon) ";
			aux+="VALUES("; 
			aux+="DEFAULT";
			aux+=",1";
			aux+=","+grupo;
			aux+=",'"+matricula+"'";
			aux+=",'"+nome+"'";
			aux+=",'"+senha+"'";
			aux+=",CURRENT_TIMESTAMP";
			aux+=","+telres;
			aux+=","+telcom;
			aux+=","+telcel;
			aux+=",'"+email+"'";
			aux+=",CURRENT_TIMESTAMP";
			aux+=",CURRENT_TIMESTAMP);";
			stmt.execute(aux);
	        con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
			return e.getMessage().toString();
		}		
		return "Usuario";
	}   

	/**
	 * Atualiza dados no banco de dados.
	 * @param  matricula matrcula do usurio
	 * @return sucesso ou falha SQL
	 */
	public String desmaterializar(String matricula)throws SQLException
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="UPDATE Usuario SET ";
			aux+="CodGru="+grupo;
			aux+=",CodStatusUsu="+status;
			aux+=",NomeUsu='"+nome+"'";
			aux+=",SenCrt='"+senha+"'";
			aux+=",TelRes="+telres;
			aux+=",TelCom="+telcom;
			aux+=",TelCel="+telcel;
			aux+=",Email='"+email+"' ";
			aux+="WHERE MatrUsu='"+matricula+"';";
			stmt.executeUpdate(aux);
	        con.close();
	        stmt.close();
	        System.out.println("SQL "+aux);
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
			return e.getMessage().toString();
		}		
		return "UsuarioAltera";
	} 

	/**
	 * Atualiza para excludo no banco de dados.
	 * @param  mat matrcula do usurio
	 * @return sucesso ou falha SQL
	 */
	public String mudarUsuario(String mat)
	{
		try
		{
			Connection con = criaConexao();
			stmt=con.createStatement();
			aux="UPDATE Usuario SET ";
			aux+="CodStatusUsu=3 ";
			aux+="WHERE MatrUsu='"+mat+"';"; 
			stmt.executeUpdate(aux);
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
			return e.getMessage().toString();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
			return e.getMessage().toString();
		}	
		return "UsuarioExclui";
	}
	
	/**
	 * Consulta no banco de dados.
	 * @param  campo registro a ser pesquisado
	 * @param  valor contedo do registro
	 * @param  status cdigo do status do usurio
	 * @return consulta, vetor contendo o resultado
	 */  	
	public Vector retornaConsulta(String status)					
	{
		String x="";
		try
		{
			consulta = new Vector();
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Usuario ";
			aux+="WHERE CodStatusUsu="+status+" ";
			aux+="ORDER BY MatrUsu;";
			rs=stmt.executeQuery(aux);
	        while(rs.next())
	        {
	        	x=rs.getString("CodUsu");
	        	x+=" - ";
	        	x+=rs.getString("MatrUsu");
	        	x+=" : ";
	        	x+=rs.getString("NomeUsu");
	        	consulta.addElement(x);
	        }
	        rs.close();
			con.close();
	        stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
		}
		return consulta;
	}
	
	/**
	 * Consulta no banco de dados com mtodo de 1 campo.
	 * @param  campo registro a ser pesquisado
	 * @param  valor contedo do registro
	 * @param  status cdigo do status do usurio
	 * @return consulta, vetor contendo o resultado
	 */  
	public Vector retornaConsulta(String campo, String valor, String status)					
	{
		String x="";
		try
		{
			consulta = new Vector();
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Usuario ";
			aux+="WHERE UPPER("+campo+") ";
			aux+="LIKE UPPER('%"+valor+"%') AND ";
			aux+="CodStatusUsu="+status+" ";
			aux+="ORDER BY "+campo+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodUsu");
				x+=" - ";
				x+=rs.getString("MatrUsu");
				x+=" : ";
				x+=rs.getString("NomeUsu");
        		consulta.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
		}
		return consulta;
	}

	/**
	 * Consulta no banco de dados com mtodo de 2 campos.
	 * @param  campo  registro 1 a ser pesquisado
	 * @param  valor  contedo do registro 1
	 * @param  campo2 registro 2 a ser pesquisado
	 * @param  valor2 contedo do registro 2
	 * @param  status cdigo do status do usurio
	 * @return consulta, vetor contendo o resultado 
	 */  
	public Vector retornaConsulta(String campo, String valor, String campo2, String valor2, String status)					
	{
		String x="";
		try
		{
			consulta = new Vector();
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Usuario ";
			aux+="WHERE ("+campo+" ";
			aux+="LIKE '%"+valor+"%' ";
			aux+="OR "+campo2+ " ";
			aux+="LIKE '%"+valor2+"%') AND ";
			aux+="CodStatusUsu="+status+" ";
			aux+="ORDER BY "+campo+";"; 
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				x=rs.getString("CodUsu");
				x+=" - ";
				x+=rs.getString("MatrUsu");
				x+=" : ";
				x+=rs.getString("NomeUsu");
				consulta.addElement(x);
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
		}	
		return consulta;
	}
	
	/**
	 * Constri objeto especificado.
	 * @param  codigo cdigo do usurio
	 * @return o objeto e seus atributos
	 */  
	public Usuario materializar(String codigo)
	{
		Usuario auxUsuario = new Usuario();
		try
		{
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Usuario "; 
			aux+="WHERE CodUsu="+codigo+";";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				auxUsuario.setMatricula(rs.getString("MatrUsu"));
				auxUsuario.setNome(rs.getString("NomeUsu"));
				auxUsuario.setGrupo(rs.getString("CodGru"));
				auxUsuario.setSenha(rs.getString("SenCrt"));
				auxUsuario.setTelcel(rs.getString("TelCel"));
				auxUsuario.setTelcom(rs.getString("TelCom"));
				auxUsuario.setTelres(rs.getString("TelRes"));
				auxUsuario.setEmail(rs.getString("Email"));
				auxUsuario.setStatus(rs.getString("CodStatusUsu"));
			}
			rs.close();
			con.close();
			stmt.close();
		}	
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
		}		
		return auxUsuario;
	}

	/**
	 * Valida login comparando com usurios cadastrados.
	 * @param  l matrcula do usurio
	 * @param  s senha do usurio
	 * @return dados do usurio com UltLogon atualizado
	 */  
	public Usuario validaLogin(String l, String s)
	{
		Usuario auxUsuario = new Usuario();
		try
		{
			int conta = 0;
			con = criaConexao();
			stmt=con.createStatement();
			aux="SELECT * FROM Usuario ";
			aux+="INNER JOIN Grupo ";
			aux+="ON Grupo.CodGru=Usuario.CodGru ";
			aux+="WHERE MatrUsu='"+l+"' ";
			aux+="AND SenCrt='"+s+"';";
			rs=stmt.executeQuery(aux);
			while(rs.next())
			{
				auxUsuario.setMatricula(rs.getString("MatrUsu"));
				auxUsuario.setNome(rs.getString("NomeUsu"));
				auxUsuario.setGrupo(rs.getString("CodGru"));
				auxUsuario.setSenha(rs.getString("SenCrt"));
				auxUsuario.setTelcel(rs.getString("TelCel"));
				auxUsuario.setTelcom(rs.getString("TelCom"));
				auxUsuario.setTelres(rs.getString("TelRes"));
				auxUsuario.setEmail(rs.getString("Email"));
				auxUsuario.setStatus(rs.getString("CodStatusUsu"));
				auxUsuario.setUltLogon(rs.getString("UltLogon"));
				auxUsuario.setDesGru(rs.getString("NomeGru"));
				conta++;
			}
			if(conta==0)
			{
				auxUsuario.setMatricula("");
				auxUsuario.setSenha("");
				auxUsuario.setGrupo("");				
			}
			else
			{
				aux="UPDATE Usuario "; 
				aux+="SET UltLogon=CURRENT_TIMESTAMP ";
				aux+="WHERE MatrUsu='"+auxUsuario.getMatricula()+"';";
				stmt.executeUpdate(aux);
				con.close();
				stmt.close();
			}
		}
		catch(SQLException e)
		{
			System.out.println("SQL Exception no BrokerUsuario: ");
			e.printStackTrace();
			System.out.println("Comando SQL: "+aux);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println("Saiu do Mtodo BrokerUsuario.");
		}	
		return auxUsuario;
	}

	// beans - gets e sets
	public String getMatricula() {
		return matricula;
	}
	public void setMatricula(String matricula) {
		this.matricula = matricula;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getGrupo() {
		return grupo;
	}
	public void setGrupo(String grupo) {
		this.grupo = grupo;
	}
	public String getSenha() {
		return senha;
	}
	public void setSenha(String senha) {
		this.senha = senha;
	}
	public String getTelres() {
		return telres;
	}
	public void setTelres(String telres) {
		this.telres = telres;
	}
	public String getTelcom() {
		return telcom;
	}
	public void setTelcom(String telcom) {
		this.telcom = telcom;
	}
	public String getTelcel() {
		return telcel;
	}
	public void setTelcel(String telcel) {
		this.telcel = telcel;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
}