package controladora;

import classepersistente.Projeto;
import broker.BrokerProjeto;
import java.sql.*;
import java.util.Vector;

/**
 * 
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class ControladoraProjeto 
{
	// declarao de variveis
	private String nome;
	private	String siglaProj;
	private String entidade;
	private	String especie;
	private String dataInicio;
	private String dataPrev;
	private String dataFim;
	private String descricao;
	private	String status;

	/**
	 * 
	 * @return 
	 */
	public String gravarProjeto ()throws SQLException
	{
		Projeto auxProjeto = new Projeto();
		auxProjeto.setSiglaProj(siglaProj);
		auxProjeto.setNome(nome);
		auxProjeto.setEntidade(entidade);
		auxProjeto.setEspecie(especie);
		auxProjeto.setDataInicio(dataInicio);
		auxProjeto.setDataPrev(dataPrev);
		auxProjeto.setDataFim(dataFim);
		auxProjeto.setDescricao(descricao);
		return auxProjeto.gravarProjeto();	
	}
	
	/**
	 * 
	 * @param  mat 
	 * @return 
	 */
	public String gravarProjeto (String sigla)throws SQLException
	{
		Projeto auxProjeto = new Projeto();
		auxProjeto.setSiglaProj(siglaProj);
		auxProjeto.setNome(nome);
		auxProjeto.setEntidade(entidade);
		auxProjeto.setEspecie(especie);
		auxProjeto.setDataInicio(dataInicio);
		auxProjeto.setDataPrev(dataPrev);
		auxProjeto.setDataFim(dataFim);
		auxProjeto.setDescricao(descricao);
		auxProjeto.setStatus(status);
		return auxProjeto.gravarProjeto(sigla);	
	}
	
	/**
	 * 
	 * @param  mat 
	 * @return 
	 */
	public String mudarProjeto(String sigla)
	{
		BrokerProjeto brok = new BrokerProjeto();
		return brok.mudarProjeto(sigla);
	}
	
	/**
	 * Faz conexo com o broker no mtodo de consulta enviando data ou nenhum (s,n,d,a,x,y).
	 * @param  t     
	 * @param  valor 
	 * @return 
	 */
	public Vector retornaProjeto(String t,String valor,String status)
	{
		BrokerProjeto brok = new BrokerProjeto();
		return  brok.retornaConsulta(t,valor,status) ; 
	}

	/**
	 *
	 * @param  codigo 
	 * @return 
	 */
	public Projeto materializar(String codigo)
	{
		BrokerProjeto brok = new BrokerProjeto();	
		return brok.materializar(codigo);
	}
	
	// beans - gets e sets
	public String getSiglaProj() {
		return siglaProj;
	}
	public void setSiglaProj(String siglaProj) {
		this.siglaProj = siglaProj;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getEntidade() {
		return entidade;
	}
	public void setEntidade(String entidade) {
		this.entidade = entidade;
	}
	public String getEspecie() {
		return especie;
	}
	public void setEspecie(String especie) {
		this.especie = especie;
	}
	public String getDataInicio() {
		return dataInicio;
	}
	public void setDataInicio(String dataInicio) {
		this.dataInicio = dataInicio;
	}
	public String getDataPrev() {
		return dataPrev;
	}
	public void setDataPrev(String dataPrev) {
		this.dataPrev = dataPrev;
	}
	public String getDataFim() {
		return dataFim;
	}
	public void setDataFim(String dataFim) {
		this.dataFim = dataFim;
	}
	public String getDescricao() {
		return descricao;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
}