package servelet;

import controladora.ControladoraEntidade;
import controladora.ControladoraConsulta;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;
import java.util.Vector;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Cadastrar Entidade"
 * @web.servlet-mapping      url-pattern="/Entidade"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Efetua cadastro de nova entidade e retorna mensagem.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class Entidade extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 12L;

	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			// valida a sesso por grupo de usurio
			int perm = 2; // nvel de acesso
			HttpSession s = request.getSession(false);
			if(s==null){response.sendRedirect("Login");}
			else{classepersistente.Usuario auxUsuario=(classepersistente.Usuario) s.getAttribute("login");
			if((auxUsuario==null)||(auxUsuario.getMatricula()==null))
			{response.sendRedirect("Login");}
			else{if(!auxUsuario.getStatus().equals("1"))
			{request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Status no est Ativo.");}
			else{if(Integer.parseInt(auxUsuario.getGrupo())>perm)
			{request.setAttribute("retorno",Integer.toString(perm));
			request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");}
			else{
			
			ControladoraEntidade auxControladoraEntidade = new ControladoraEntidade();
			String acao=request.getParameter("Acao");
			String nomeEnt=request.getParameter("NomeEnt");
			System.out.println("Ao -> "+acao);
			System.out.println("Nome -> "+nomeEnt);
			String retorno="";

		if (acao != null)
		{	
			// efetua pesquisa por entidades pai
			if(acao.equals("Pesquisar"))
			{
				Vector ents; 
				String filho=request.getParameter("filho");	
				ControladoraConsulta cont = new ControladoraConsulta(); 
				ents=cont.retornaEntidade(filho);
				request.setAttribute("ents",ents);
				request.setAttribute("filho",filho);
				request.setAttribute("nomeEnt",nomeEnt);
				request.getRequestDispatcher("jsp/cadastro/entcad.jsp").forward(request,response);
			}
			else
			{
				// carrega as variveis da pgina
				String tipoEntidade=request.getParameter("filho");
				String entidade=request.getParameter("pai");
				String descEnt=request.getParameter("DescEnt");
				
			    // atribui as variveis na controladora
				auxControladoraEntidade.setTipoEntidade(tipoEntidade);
				auxControladoraEntidade.setEntidade(entidade);
				auxControladoraEntidade.setNome(nomeEnt);
				auxControladoraEntidade.setDescEnt(descEnt);
			
				// envia para a controladora o mtodo gravar com parmetro do servelet 
				try
				{
					retorno=auxControladoraEntidade.gravarEntidade();
					System.out.println("Enviou -> "+nomeEnt);
					// retorna falha ou sucesso ao gravar no banco de dados
					if(retorno == "Entidade")
					{
						System.out.println("Gravou -> "+nomeEnt);
						request.setAttribute("retorno",retorno);
						request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
					}
					else
					{
						System.out.println("No gravou -> "+retorno);
						request.setAttribute("retorno",retorno);
						request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
					}
				}
				catch(Exception e)
				{
					System.out.println("No enviou -> "+e.getMessage());
				}
			}
		}
		else
		{
			request.getRequestDispatcher("jsp/cadastro/entcad.jsp").forward(request,response);
		}

		}}}}}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}			
	}
}
