package servelet;

import controladora.ControladoraLogin;
import classepersistente.Usuario;
import javax.servlet.http.*;
import javax.servlet.http.HttpServlet;
import javax.servlet.ServletException;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Validar Login"
 * @web.servlet-mapping      url-pattern="/Login"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Valida login e senha com cadastro de usurio.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class Login extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 01L;

	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			ControladoraLogin auxControldadoraLogin = new ControladoraLogin();
			String acao=request.getParameter("Acao");
			String login=request.getParameter("MatrUsu");
			String senha=request.getParameter("SenCrt");
			System.out.println("Ao -> "+acao);
			System.out.println("Login -> "+login);
			String retorno="";
			
		if( acao != null)
		{
			// se for preenchido: MatrUsu
			if("".compareTo(login)!=0)
			{
				// se for preenchido: SenCrt
				if("".compareTo(senha)!=0)
				{
					Usuario auxUsuario=auxControldadoraLogin.validaLogin(login,senha);
					System.out.println("Permisso -> "+auxUsuario.getGrupo());
					// envia valores para: HttpSession
					if("".compareTo(auxUsuario.getMatricula())!= 0 && auxUsuario.getGrupo() != null)
					{
						System.out.println("Acesso Autorizado.");
						HttpSession s = request.getSession(true);
    					s.setAttribute("login",auxUsuario);	
						response.sendRedirect("Principal");
					}
					// retorna falha de login
					else
					{
						System.out.println("No Autorizado.");
						retorno="Login ou Senha Invlido.";
						request.setAttribute("login",login);
						request.setAttribute("retorno",retorno);
						request.getRequestDispatcher("jsp/login/index.jsp").forward(request,response);
					}
				}
				// retorna sem senha
				else
				{
					retorno="O campo Senha deve ser preenchido!";
					request.setAttribute("login",login);
					request.setAttribute("retorno",retorno);
					request.getRequestDispatcher("jsp/login/index.jsp").forward(request,response);
				}
			}
			// retorna sem login
			else
			{
				retorno="O campo Login deve ser preenchido!";
				request.setAttribute("retorno",retorno);
				request.getRequestDispatcher("jsp/login/index.jsp").forward(request,response);
			}
		}
		else
		{
			request.getRequestDispatcher("jsp/login/index.jsp").forward(request,response);
		}
		
		}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}								
	}
}