package servelet;

import classepersistente.Usuario;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServlet;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Principal"
 * @web.servlet-mapping      url-pattern="/Principal"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Exibe a pgina de entrada.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class Principal extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 03L;
	
	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		// valida a sesso por grupo de usurio
		int perm = 3; // nvel de acesso
		HttpSession s = request.getSession(false);
		if(s == null)
		{
			response.sendRedirect("Login");
		}
		else
		{
			Usuario auxUsuario = (Usuario) s.getAttribute("login");
			if((auxUsuario == null) || (auxUsuario.getMatricula() == null))
			{
				response.sendRedirect("Login");
			}
			else
			{
				if(! auxUsuario.getStatus().equals("1"))
				{
					request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
					System.out.println("Acesso No Autorizado. Status no est Ativo.");
				}
				else
				{
					if(Integer.parseInt(auxUsuario.getGrupo()) > perm)
					{
						request.setAttribute("retorno",Integer.toString(perm));
						request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
						System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");
					}
					else
					{
						request.getRequestDispatcher("jsp/principal/index.jsp").forward(request,response);
					}
				}
			}
		}
	}		
}