package servelet;

import classepersistente.Usuario;
import controladora.ControladoraProjeto;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Cadastrar Projeto"
 * @web.servlet-mapping      url-pattern="/Projeto"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Efetua cadastro de novo projeto e retorna mensagem.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class Projeto extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 11L;

	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			// valida a sesso por grupo de usurio
			int perm = 1; // nvel de acesso
			HttpSession s = request.getSession(false);
			if(s==null){response.sendRedirect("Login");}
			else{Usuario auxUsuario=(Usuario) s.getAttribute("login");
			if((auxUsuario==null)||(auxUsuario.getMatricula()==null))
			{response.sendRedirect("Login");}
			else{if(! auxUsuario.getStatus().equals("1"))
			{request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Status no est Ativo.");}
			else{if(Integer.parseInt(auxUsuario.getGrupo())>perm)
			{request.setAttribute("retorno",Integer.toString(perm));
			request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");}
			else{
			
			ControladoraProjeto auxControladoraProjeto = new ControladoraProjeto();
			String acao=request.getParameter("Acao");
			String nome=request.getParameter("NomeProj");
			System.out.println("Ao -> "+acao);
			System.out.println("Nome -> "+nome);
			String retorno="";
			
		if(acao != null)
		{	
			// carrega as variveis da pgina
			String sigla =request.getParameter("SiglaProj");
			String entidade=request.getParameter("CodEnt");
			String especie=request.getParameter("CodEsp");
			String dataInicio=request.getParameter("DataIniProj");
			String dataPrev=request.getParameter("DataPrevProj");
			String descricao=request.getParameter("DescProj");
			
			// atribui vazio a valores nulos
			if(dataPrev.equals("")||dataPrev.equals(" //")){dataPrev="01/01/9999";}
			if(descricao.equals("")){descricao="NULL";}			
			
			// atribui as variveis na controladora
			auxControladoraProjeto.setNome(nome);
			auxControladoraProjeto.setSiglaProj(sigla);
			auxControladoraProjeto.setEntidade(entidade);
			auxControladoraProjeto.setEspecie(especie);
			auxControladoraProjeto.setDataInicio(dataInicio);
			auxControladoraProjeto.setDataPrev(dataPrev);
			auxControladoraProjeto.setDescricao(descricao);

			// envia para a controladora o mtodo gravar com parmetro do servelet 
			try
			{
				retorno=auxControladoraProjeto.gravarProjeto();
				System.out.println("Enviou -> "+nome);
				// retorna falha ou sucesso ao gravar no banco de dados
				if(retorno == "Projeto")
				{
					System.out.println("Gravou -> "+nome);
					request.setAttribute("retorno",retorno);
					request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
				}
				else
				{
					System.out.println("No gravou -> "+retorno);
					// retorna falha personalizada
					if(retorno.equals("ERROR: duplicate key violates unique constraint "+'"'+"projeto_siglaproj_key"+'"'))
					{
						retorno = "a sigla informada est sendo utilizada por outro projeto.";
					}
					request.setAttribute("retorno",retorno);
					request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
				}
			}
			catch(Exception e)
			{
				System.out.println("No enviou -> "+e.getMessage());
			}
		}
		else
		{
			request.getRequestDispatcher("jsp/projeto/projcad.jsp").forward(request,response);
		}
		
		}}}}}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}		
	}
}