package servelet;

import controladora.ControladoraProjeto;
import classepersistente.Projeto;
import classepersistente.Usuario;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;
import java.util.*;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Alterar Projeto"
 * @web.servlet-mapping      url-pattern="/ProjetoAltera"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Efetua consulta, alterao e marca projeto como excludo.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class ProjetoAltera extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 41L;
	
	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			// valida a sesso por grupo de usurio
			int perm = 1; // nvel de acesso
			HttpSession s = request.getSession(false);
			if(s==null){response.sendRedirect("Login");}
			else{Usuario auxUsuario=(Usuario) s.getAttribute("login");
			if((auxUsuario==null)||(auxUsuario.getMatricula()==null))
			{response.sendRedirect("Login");}
			else{if(! auxUsuario.getStatus().equals("1"))
			{request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Status no est Ativo.");}
			else{if(Integer.parseInt(auxUsuario.getGrupo())>perm)
			{request.setAttribute("retorno",Integer.toString(perm));
			request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");}
			else{
			
			ControladoraProjeto auxControladoraProjeto = new ControladoraProjeto();
			String acao=request.getParameter("Acao");
			String sigla=request.getParameter("SiglaProj");
			String nome=request.getParameter("NomeProj");
			String dataInicio=request.getParameter("DataIniProj");
			String status=request.getParameter("CodStatusProj");
			System.out.println("Ao -> "+acao);
			System.out.println("Sigla -> "+sigla);
			request.setAttribute("sigla",sigla);
			request.setAttribute("nome",nome);
			request.setAttribute("dataInicio",dataInicio);
			request.setAttribute("status",status);
			Vector resposta = new Vector();
			String retorno="";
			String t="";
			
			if (acao != null)
			{
			// efetua consulta
			if(acao.equals("Consultar"))
			{
				// se for preenchido: NomeProj ou NomeProj
				if (("".compareTo(sigla)!=0)||("".compareTo(nome)!=0))
				{
					// se for preenchido: SiglaProj
					if ("".compareTo(sigla)!=0)
					{
						// se for preenchido: SiglaProj e DataIniProj
						if ("".compareTo(dataInicio)!=0)
						{ 	t="x";
							String valor=sigla+" - "+dataInicio;
							resposta=auxControladoraProjeto.retornaProjeto(t,valor,status);
							request.setAttribute("tabela",resposta);
							request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
						}
						// retorna a pesquisa por: SiglaProj
						else
						{	t="s";
							resposta=auxControladoraProjeto.retornaProjeto(t,sigla,status);
							request.setAttribute("tabela",resposta);
							request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
						}
					}
					else
					{
						// se for preenchido: NomeProj e DataIniProj
						if ("".compareTo(dataInicio)!=0)
						{ 	t="y";
							String valor=nome+" - "+dataInicio;
							resposta=auxControladoraProjeto.retornaProjeto(t,valor,status);
							request.setAttribute("tabela",resposta);
							request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
						}
						// retorna a pesquisa por: NomeProj
						else
						{	t="n";
							resposta=auxControladoraProjeto.retornaProjeto(t,nome,status);
							request.setAttribute("tabela",resposta);
							request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
						}
					}
				}
				else
				{	
					// retorna a pesquisa por: DataIniProj
					if ("".compareTo(dataInicio)!=0)
					{ 	t="d";
						resposta=auxControladoraProjeto.retornaProjeto(t,dataInicio,status);
						request.setAttribute("tabela",resposta);
						request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
					}
					// se nada for preenchido
					else
					{	t="a";
						dataInicio="";
						resposta=auxControladoraProjeto.retornaProjeto(t,dataInicio,status);
						request.setAttribute("tabela",resposta);
						request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
					}
				}
			}
			else
			{ 
				// envia valores para: projalt
				if(acao.equals("Carregar"))
				{
						String codigo=request.getParameter("codigo");
						Projeto auxProjeto = auxControladoraProjeto.materializar(codigo);
						request.setAttribute("dados",auxProjeto);
						request.getRequestDispatcher("jsp/projeto/projalt.jsp").forward(request,response);
				}
				else
				{
					// efetua alterao
					if(acao.equals("Alterar"))
					{
						
						// carrega as variveis da pgina
						String entidade=request.getParameter("CodEnt");
						String especie=request.getParameter("CodEsp");
						String dataPrev=request.getParameter("DataPrevProj");
						String descricao=request.getParameter("DescProj");
						
						// atribui vazio a valores nulos
						if(dataPrev.equals("")){dataPrev="01/01/9999";}
						if(descricao.equals("")){descricao="NULL";}			
						
						// atribui as variveis na controladora
						auxControladoraProjeto.setNome(nome);
						auxControladoraProjeto.setSiglaProj(sigla);
						auxControladoraProjeto.setEntidade(entidade);
						auxControladoraProjeto.setEspecie(especie);
						auxControladoraProjeto.setDataInicio(dataInicio);
						auxControladoraProjeto.setDataPrev(dataPrev);
						auxControladoraProjeto.setDescricao(descricao);

						// envia para a controladora o mtodo gravar com parmetro do servelet
						try
						{			
							retorno=auxControladoraProjeto.gravarProjeto(sigla); 
							t="n";
							resposta=auxControladoraProjeto.retornaProjeto(t,nome,status);
							request.setAttribute("tabela",resposta);
							// retorna falha ou sucesso ao gravar no banco de dados
							if(retorno == "ProjetoAltera")
							{
								System.out.println("Alterou -> "+sigla);
								request.setAttribute("retorno",retorno);
								request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
							}
							else
							{
								System.out.println("No alterou -> "+retorno);
								// retorna falha personalizada
								if(retorno.equals("ERROR: duplicate key violates unique constraint "+'"'+"projeto_siglaproj_key"+'"'))
								{
									retorno = "a sigla informada est sendo utilizada por outro projeto.";
								}
								request.setAttribute("retorno",retorno);
								request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
							}
						}
						catch(Exception e)
						{
							System.out.println("No enviou -> "+e.getMessage());
						}
					}
					else
					{
						// efetua excluso
						if(acao.equals("Excluir"))
						{
							// envia para a controladora o mtodo gravar com parmetro do servelet
							try
							{							
								retorno=auxControladoraProjeto.mudarProjeto(sigla);	
								// retorna falha ou sucesso ao gravar no banco de dados
								if(retorno == "ProjetoExclui")
								{
									System.out.println("Excluiu -> "+sigla);
									request.setAttribute("retorno",retorno);
									request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
								}
								else
								{
									System.out.println("No excluiu -> "+retorno);
									request.setAttribute("retorno",retorno);
									request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
								}
							}
							catch(Exception e)
							{
								System.out.println("No enviou -> "+e.getMessage());
							}				
						}
					}
				}			
			}
		}	
		else
		{
			request.getRequestDispatcher("jsp/projeto/projcon.jsp").forward(request,response);
		}

		}}}}}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}	
	}
}