package servelet;

import classepersistente.Usuario;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServlet;
import javax.servlet.ServletException;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Cancelar Login"
 * @web.servlet-mapping      url-pattern="/Sair"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Efetua logout de usurio.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class Sair extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 02L;
	
	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			// valida a sesso por grupo de usurio
			int perm = 3; // nvel de acesso
			HttpSession s = request.getSession(false);
			if(s==null){response.sendRedirect("Login");}
			else{Usuario auxUsuario=(Usuario) s.getAttribute("login");
			if((auxUsuario==null)||(auxUsuario.getMatricula()==null))
			{response.sendRedirect("Login");}
			else{if(! auxUsuario.getStatus().equals("1"))
			{request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Status no est Ativo.");}
			else{if(Integer.parseInt(auxUsuario.getGrupo())>perm)
			{request.setAttribute("retorno",Integer.toString(perm));
			request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");}
			else{
				
		String acao=request.getParameter("Acao");
		
		if(acao != null)
		{
			// se for selecionado No
			if(acao.equals("No"))
			{
				response.sendRedirect("Principal");
			}
			// se for selecionado Sim
			else
			{
				System.out.println("Acesso Finalizado.");
				response.sendRedirect("Login");
				s = request.getSession(false);
				s.invalidate();
			}
		}
		else
		{
			request.getRequestDispatcher("jsp/sair/sair.jsp").forward(request,response);
		}
			
		}}}}}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}	
	}	
}