package servelet;

import controladora.ControladoraUsuario;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Cadastrar Usurio"
 * @web.servlet-mapping      url-pattern="/Usuario"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Efetua cadastro de novo usurio e retorna mensagem.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class Usuario extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 10L;
	
	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}
	
	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			// valida a sesso por grupo de usurio
			int perm = 1; // nvel de acesso
			HttpSession s = request.getSession(false);
			if(s==null){response.sendRedirect("Login");}
			else{classepersistente.Usuario auxUsuario=(classepersistente.Usuario) s.getAttribute("login");
			if((auxUsuario==null)||(auxUsuario.getMatricula()==null))
			{response.sendRedirect("Login");}
			else{if(!auxUsuario.getStatus().equals("1"))
			{request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Status no est Ativo.");}
			else{if(Integer.parseInt(auxUsuario.getGrupo())>perm)
			{request.setAttribute("retorno",Integer.toString(perm));
			request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");}
			else{
			
			ControladoraUsuario auxControladoraUsuario = new ControladoraUsuario();
			String acao=request.getParameter("Acao");
			String nome=request.getParameter("NomeUsu");
			System.out.println("Ao -> "+acao);
			System.out.println("Nome -> "+nome);
			String retorno="";

		if(acao != null)
		{	
			// carrega as variveis da pgina
			String matricula=request.getParameter("MatrUsu");
			String grupo=request.getParameter("CodGru");
			String senha=request.getParameter("SenCrt");
			String telres=request.getParameter("TelRes");
			String telcom=request.getParameter("TelCom");
			String telcel=request.getParameter("TelCel");
		    String email=request.getParameter("Email");

		    // atribui vazio a valores nulos
			if(telres.equals("")){telres="NULL";}
			if(telcom.equals("")){telcom="NULL";}
			if(telcel.equals("")){telcel="NULL";}

		    // atribui as variveis na controladora
			auxControladoraUsuario.setMatricula(matricula);
			auxControladoraUsuario.setNome(nome);
		    auxControladoraUsuario.setGrupo(grupo);
			auxControladoraUsuario.setSenha(senha);
			auxControladoraUsuario.setTelres(telres);
			auxControladoraUsuario.setTelcom(telcom);
			auxControladoraUsuario.setTelcel(telcel);
			auxControladoraUsuario.setEmail(email);

			// envia para a controladora o mtodo gravar com parmetro do servelet 
			try
			{
				retorno=auxControladoraUsuario.gravarUsuario();
				System.out.println("Enviou -> "+nome);
				// retorna falha ou sucesso ao gravar no banco de dados
				if(retorno == "Usuario")
				{
					System.out.println("Gravou -> "+nome);
					request.setAttribute("retorno",retorno);
					request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
				}
				else
				{
					System.out.println("No gravou -> "+retorno);
					// retorna falha personalizada
					if(retorno.equals("ERROR: duplicate key violates unique constraint "+'"'+"usuario_matrusu_key"+'"'))
					{
						retorno = "a matrcula informada est sendo utilizada por outro usurio.";
					}
					request.setAttribute("retorno",retorno);
					request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
				}
			}
			catch(Exception e)
			{
				System.out.println("No enviou -> "+e.getMessage());
			}
		}
		else
		{
			request.getRequestDispatcher("jsp/gerenciamento/usucad.jsp").forward(request,response);
		}
		
		}}}}}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}	
	}
}