package servelet;

import controladora.ControladoraUsuario;
import classepersistente.Usuario;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;
import java.util.*;

/**
 * Servlet Class
 *
 * @web.servlet              name="SISINC"
 *                           display-name="Sistema de Incubao Experimental"
 *                           description="Alterar Usurio"
 * @web.servlet-mapping      url-pattern="/UsuarioAltera"
 * @web.servlet-init-param   name=""
 *                           value=""
 */

/**
 * Efetua consulta, alterao e marca usurio como excludo.
 * <p>
 * Recebe as variveis da pgina do respectivo formulrio, seta as
 * variveis da controladora direcionando para uma pgina de falha
 * ou sucesso dependendo do resultado de retorno.
 * @author      Arthur Maaneiro Magyar
 * @author      Fbio Glauco dos Santos
 * @author      Luciano Padilha
 * @version     1.0
 */
public class UsuarioAltera extends HttpServlet
{
	// declarao do identificador universal da classe
	private static final long serialVersionUID = 40L;
	
	/**
	 *  
	 */
	public void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
	{
		doPost(request,response);
	}

	/**
	 *  
	 */
	public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
	throws javax.servlet.ServletException, java.io.IOException
	{
		try
		{
			// valida a sesso por grupo de usurio
			int perm = 1; // nvel de acesso
			HttpSession s = request.getSession(false);
			if(s==null){response.sendRedirect("Login");}
			else{Usuario auxUsuario=(Usuario) s.getAttribute("login");
			if((auxUsuario==null)||(auxUsuario.getMatricula()==null))
			{response.sendRedirect("Login");}
			else{if(!auxUsuario.getStatus().equals("1"))
			{request.getRequestDispatcher("scripts/status.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Status no est Ativo.");}
			else{if(Integer.parseInt(auxUsuario.getGrupo())>perm)
			{request.setAttribute("retorno",Integer.toString(perm));
			request.getRequestDispatcher("scripts/perm.jsp").forward(request,response);
			System.out.println("Acesso No Autorizado. Necessrio ao menos Nvel "+perm+".");}
			else{
			
			ControladoraUsuario auxControladoraUsuario = new ControladoraUsuario();
			String acao=request.getParameter("Acao");
			String matricula=request.getParameter("MatrUsu");
			String nome=request.getParameter("NomeUsu");
			String status=request.getParameter("CodStatusUsu");
			System.out.println("Ao -> "+acao);
			System.out.println("Nome -> "+nome);
			request.setAttribute("matricula",matricula);
			request.setAttribute("nome",nome);
			request.setAttribute("status",status);
			Vector resposta = new Vector();
			String retorno="";
		
		if(acao != null)
		{
			// efetua consulta
			if(acao.equals("Consultar"))
			{
				// se for preenchido: MatrUsu
				if ("".compareTo(matricula)!=0)
				{
					// se for preenchido: MatrUsu e NomeUsu
					if("".compareTo(nome)!=0)
					{  
						resposta=auxControladoraUsuario.retornaUsuario("NomeUsu",nome,"MatrUsu",matricula,status);
						request.setAttribute("tabela",resposta);
						request.getRequestDispatcher("jsp/gerenciamento/usucon.jsp").forward(request,response);
					}
					// retorna a pesquisa por: MatrUsu
					else
					{
						resposta=auxControladoraUsuario.retornaUsuario("MatrUsu",matricula,status);
						request.setAttribute("tabela",resposta);
						request.getRequestDispatcher("jsp/gerenciamento/usucon.jsp").forward(request,response);
					}	
				}
				else
				{
					// se for preenchido: NomeUsu
					if ("".compareTo(nome)!=0)
					{
						resposta=auxControladoraUsuario.retornaUsuario("NomeUsu",nome,status);	
						request.setAttribute("tabela",resposta);
						request.getRequestDispatcher("jsp/gerenciamento/usucon.jsp").forward(request,response);
					}
					// se nada for preenchido
					else
					{
						resposta=auxControladoraUsuario.retornaUsuario(status);
						request.setAttribute("tabela",resposta);
						request.getRequestDispatcher("jsp/gerenciamento/usucon.jsp").forward(request,response);	
					}
				}
			}
			else
			{
				// envia valores para: usualt
				if(acao.equals("Carregar"))
				{
					String codigo=request.getParameter("codigo");
					auxUsuario = auxControladoraUsuario.materializar(codigo);
					request.setAttribute("dados",auxUsuario);
					request.getRequestDispatcher("jsp/gerenciamento/usualt.jsp").forward(request,response);
				}
				else
				{
					// efetua alterao
					if(acao.equals("Alterar"))
					{
					
						// carrega as variveis da pgina
						String grupo=request.getParameter("CodGru");
						String senha=request.getParameter("SenCrt");
						String telres=request.getParameter("TelRes");
						String telcom=request.getParameter("TelCom");
						String telcel=request.getParameter("TelCel");
						String email=request.getParameter("Email");
				   					
						// atribui vazio a valores nulos
						if(telres.equals("")){telres="NULL";}
						if(telcom.equals("")){telcom="NULL";}
						if(telcel.equals("")){telcel="NULL";}

						// atribui as variveis na controladora
						auxControladoraUsuario.setMatricula(matricula);
						auxControladoraUsuario.setNome(nome);
						auxControladoraUsuario.setGrupo(grupo);
						auxControladoraUsuario.setSenha(senha);
						auxControladoraUsuario.setTelres(telres);
						auxControladoraUsuario.setTelcom(telcom);
						auxControladoraUsuario.setTelcel(telcel);
						auxControladoraUsuario.setEmail(email);
						auxControladoraUsuario.setStatus(status);
					
						// envia para a controladora o mtodo gravar com parmetro do servelet
						try
						{
							retorno=auxControladoraUsuario.gravarUsuario(matricula);
							resposta=auxControladoraUsuario.retornaUsuario("NomeUsu",nome,status);
							request.setAttribute("tabela",resposta);
							// retorna falha ou sucesso ao gravar no banco de dados
							if(retorno == "UsuarioAltera")
							{
								System.out.println("Alterou -> "+nome);
								request.setAttribute("retorno",retorno);
								request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
							}
							else
							{
								System.out.println("No alterou -> "+retorno);
								// retorna falha personalizada
								if(retorno.equals("ERROR: duplicate key violates unique constraint "+'"'+"usuario_matrusu_key"+'"'))
								{
									retorno = "a matrcula informada est sendo utilizada por outro usurio.";
								}
								request.setAttribute("retorno",retorno);
								request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
							}
						}
						catch(Exception e)
						{
							System.out.println("No enviou -> "+e.getMessage());
						}
					}
					else
					{
						// efetua excluso
						if(acao.equals("Excluir"))
						{
							// envia para a controladora o mtodo gravar com parmetro do servelet
							try
							{
								retorno=auxControladoraUsuario.mudarUsuario(matricula);
								// retorna falha ou sucesso ao gravar no banco de dados
								if(retorno == "UsuarioExclui")
								{
									System.out.println("Excluiu -> "+nome);
									request.setAttribute("retorno",retorno);
									request.getRequestDispatcher("scripts/sucesso.jsp").forward(request,response);
								}
								else
								{
									System.out.println("No excluiu -> "+retorno);
									request.setAttribute("retorno",retorno);
									request.getRequestDispatcher("scripts/falha.jsp").forward(request,response);
								}	
							}
							catch(Exception e)
							{
								System.out.println("No enviou -> "+e.getMessage());
							}
						}
					}
				}
			}
		}
		else
		{
			request.getRequestDispatcher("jsp/gerenciamento/usucon.jsp").forward(request,response);
		}

		}}}}}
		catch(ServletException e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.out.println("Saiu da Classe.");
		}	
	}
}